
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         sqlyyparse
#define yylex           sqlyylex
#define yyerror         sqlyyerror
#define yylval          sqlyylval
#define yychar          sqlyychar
#define yydebug         sqlyydebug
#define yynerrs         sqlyynerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 19 "amga_sql_yacc.y++"


#include "amga_sql.h"
#include "server/MDStandalone.h"
#include "server/DBHelper.h"
#include "server/MDInterpreter.h"
#include "util/guidHelper.h"

static int debug = 0;
#include "debug.h"

#define YYLEX_PARAM scanner
#define YYPARSE_PARAM scanner
#define yylex sqlyylex

#define _ASP ((AmgaSqlParser *)YYPARSE_PARAM) 

#define YYSTYPE char *

int yylex(YYSTYPE* lvalp, void* a) ;
void yyerror (const char *s) ;


char* __concat(char* a, char* b);
char* __concat3(char* a, char* b, char* c);
char* __Bconcat(char* a, char* b);
char* __Bconcat3(char* a, char* b, char* c);
int getAllColumn(AmgaSqlParser *scanner, std::string& column, bool insert);
int processTable(AmgaSqlParser *scanner, std::string table, bool alias, bool checkPerm, std::string& result) ;
char* fillPermission(AmgaSqlParser *scanner, char permission);


/* concaterating macros */
#define  __C0(aa)  	 aa = strdup(" "); 
#define  __C1(aa,a1) 	 aa = strdup(a1); free(a1);
#define  __C2(aa,a1,a2) 	 aa = __concat(a1,a2); 
#define  __C3(aa,a1,a2,a3) 	 aa = __concat3(a1,a2,a3); 
#define  __C4(aa,a1,a2,a3,a4) 	 char* t1 = __concat3(a1,a2,a3); aa = __concat(t1,a4); 
#define  __C5(aa,a1,a2,a3,a4,a5) 	 char* t1 = __concat3(a1,a2,a3); aa = __concat3(t1,a4,a5); 
#define  __C6(aa,a1,a2,a3,a4,a5,a6) 	 char* t1 = __concat3(a1,a2,a3); char* t2 = __concat3(a4,a5,a6); aa = __concat(t1,t2); 
#define  __C7(aa,a1,a2,a3,a4,a5,a6,a7) 	 char* t1 = __concat3(a1,a2,a3); char* t2 = __concat3(a4,a5,a6); aa = __concat3(t1,t2,a7); 
#define  __C8(aa,a1,a2,a3,a4,a5,a6,a7,a8) 	 char* t1 = __concat3(a1,a2,a3); char* t2 = __concat3(a4,a5,a6); char* t3 = __concat(a7,a8); aa = __concat3(t1,t2,t3); 
#define  __C9(aa,a1,a2,a3,a4,a5,a6,a7,a8,a9) 	 char* t1 = __concat3(a1,a2,a3); char* t2 = __concat3(a4,a5,a6); char* t3 = __concat3(a7,a8,a9); aa = __concat3(t1,t2,t3); 

#define  __B2(aa,a1,a2) 	 aa = __Bconcat(a1,a2); 
#define  __B3(aa,a1,a2,a3) 	 aa = __Bconcat3(a1,a2,a3); 
#define  __B4(aa,a1,a2,a3,a4) 	 char*t1 = __Bconcat3(a1,a2,a3); aa = __Bconcat(t1,a4); 
#define  __B5(aa,a1,a2,a3,a4,a5) 	char*t1 = __Bconcat3(a1,a2,a3); aa = __Bconcat3(t1,a4,a5); 

#define  __A1(aa)    if( _ASP->countingColumn() )  _ASP->tmpReferAttr = aa;



/* Line 189 of yacc.c  */
#line 135 "amga_sql_yacc.cpp"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     OR = 258,
     AND = 259,
     NOT = 260,
     EQUAL = 261,
     COMPARISON = 262,
     UMINUS = 263,
     NAME = 264,
     STRING = 265,
     TNAME = 266,
     INTNUM = 267,
     APPROXNUM = 268,
     ALL = 269,
     AMMSC = 270,
     AMMSC2 = 271,
     ANY = 272,
     AS = 273,
     ASC = 274,
     AUTHORIZATION = 275,
     BETWEEN = 276,
     BY = 277,
     CHARACTER = 278,
     CHECK = 279,
     CLOSE = 280,
     COMMIT = 281,
     CONTINUE = 282,
     CREATE = 283,
     CURRENT = 284,
     CURSOR = 285,
     DECIMAL = 286,
     DECLARE = 287,
     DEFAULT = 288,
     DELETE = 289,
     DESC = 290,
     DISTINCT = 291,
     DOUBLE = 292,
     ESCAPE = 293,
     EXISTS = 294,
     FETCH = 295,
     FLOAT = 296,
     FOR = 297,
     FOREIGN = 298,
     FOUND = 299,
     FROM = 300,
     GOTO = 301,
     GRANT = 302,
     GROUP = 303,
     HAVING = 304,
     IN = 305,
     INDICATOR = 306,
     INSERT = 307,
     INTEGER = 308,
     INTO = 309,
     IS = 310,
     KEY = 311,
     LANGUAGE = 312,
     LIKE = 313,
     MODULE = 314,
     NULLX = 315,
     NUMERIC = 316,
     OF = 317,
     ON = 318,
     OPEN = 319,
     OPTION = 320,
     ORDER = 321,
     PRECISION = 322,
     PRIMARY = 323,
     PRIVILEGES = 324,
     PROCEDURE = 325,
     PUBLIC = 326,
     REAL = 327,
     REFERENCES = 328,
     ROLLBACK = 329,
     SCHEMA = 330,
     SELECT = 331,
     SET = 332,
     SMALLINT = 333,
     SOME = 334,
     SQLCODE = 335,
     SQLERROR = 336,
     TABLE = 337,
     TO = 338,
     UNION = 339,
     UNIQUE = 340,
     UPDATE = 341,
     USER = 342,
     VALUES = 343,
     VIEW = 344,
     WHENEVER = 345,
     WHERE = 346,
     WITH = 347,
     WORK = 348,
     COBOL = 349,
     FORTRAN = 350,
     PASCAL = 351,
     PLI = 352,
     C = 353,
     ADA = 354,
     JOIN = 355,
     INNER = 356,
     OUTER = 357,
     LEFT = 358,
     RIGHT = 359,
     FULL = 360,
     USING = 361,
     NATURAL = 362,
     INDEX = 363,
     LIMIT = 364,
     OFFSET = 365
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 287 "amga_sql_yacc.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  38
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   618

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  125
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  77
/* YYNRULES -- Number of rules.  */
#define YYNRULES  178
/* YYNRULES -- Number of states.  */
#define YYNSTATES  316

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   365

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    12,     2,
     119,   120,    10,     8,   118,     9,   121,    11,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   122,   117,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   123,     2,   124,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    13,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     7,     9,    11,    13,    15,    17,
      24,    27,    32,    39,    47,    55,    57,    61,    62,    66,
      67,    71,    73,    77,    80,    83,    84,    86,    88,    93,
      95,    97,   101,   103,   105,   106,   108,   110,   112,   116,
     120,   124,   126,   129,   131,   133,   135,   139,   144,   146,
     148,   150,   154,   159,   164,   169,   171,   176,   177,   178,
     179,   181,   185,   187,   190,   192,   195,   198,   199,   203,
     205,   209,   210,   213,   214,   218,   222,   225,   229,   231,
     233,   235,   237,   239,   241,   243,   245,   249,   253,   257,
     261,   268,   274,   280,   285,   286,   289,   294,   298,   303,
     307,   314,   320,   322,   326,   331,   336,   338,   340,   342,
     346,   349,   353,   357,   361,   365,   369,   373,   377,   380,
     383,   385,   387,   389,   391,   395,   397,   401,   403,   407,
     409,   411,   413,   415,   420,   425,   431,   437,   442,   447,
     454,   456,   459,   462,   464,   467,   470,   472,   474,   476,
     478,   480,   482,   484,   487,   489,   493,   497,   498,   502,
     506,   509,   511,   515,   522,   523,   525,   526,   528,   530,
     533,   538,   539,   541,   544,   546,   548,   550,   551
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     126,     0,    -1,   128,   127,    -1,    -1,   117,    -1,   129,
      -1,   130,    -1,   131,    -1,   132,    -1,    40,    51,   154,
     158,   155,   145,    -1,   146,   135,    -1,   146,   135,   115,
      18,    -1,   146,   135,   115,    18,   116,    18,    -1,    58,
      60,   154,   158,   155,   134,   139,    -1,    92,   154,   158,
     155,    83,   143,   145,    -1,   192,    -1,   133,   118,   192,
      -1,    -1,   119,   133,   120,    -1,    -1,    72,    28,   136,
      -1,   137,    -1,   136,   118,   137,    -1,    18,   138,    -1,
     189,   138,    -1,    -1,    25,    -1,    41,    -1,    94,   119,
     140,   120,    -1,   150,    -1,   141,    -1,   140,   118,   141,
      -1,   182,    -1,    66,    -1,    -1,    20,    -1,    42,    -1,
     144,    -1,   143,   118,   144,    -1,   192,     6,   176,    -1,
     192,     6,    66,    -1,   156,    -1,   156,   159,    -1,   147,
      -1,   193,    -1,   149,    -1,   146,    90,   148,    -1,   146,
      90,    20,   148,    -1,   149,    -1,   193,    -1,   150,    -1,
     119,   147,   120,    -1,   151,   145,   160,   162,    -1,    82,
     142,   152,   153,    -1,    82,   142,    10,   153,    -1,   177,
      -1,    51,   154,   157,   155,    -1,    -1,    -1,    -1,   158,
      -1,   157,   118,   158,    -1,   186,    -1,   186,   179,    -1,
     193,    -1,   184,   180,    -1,    97,   163,    -1,    -1,    54,
      28,   161,    -1,   189,    -1,   161,   118,   189,    -1,    -1,
      55,   163,    -1,    -1,   163,     3,   163,    -1,   163,     4,
     163,    -1,     5,   163,    -1,   119,   163,   120,    -1,   164,
      -1,   165,    -1,   166,    -1,   167,    -1,   169,    -1,   170,
      -1,   172,    -1,   174,    -1,   176,     7,   176,    -1,   176,
       6,   176,    -1,   176,     7,   175,    -1,   176,     6,   175,
      -1,   176,     5,    27,   176,     4,   176,    -1,   176,    27,
     176,     4,   176,    -1,   176,     5,    64,   182,   168,    -1,
     176,    64,   182,   168,    -1,    -1,    44,   182,    -1,   189,
      61,     5,    66,    -1,   189,    61,    66,    -1,   176,     5,
      56,   175,    -1,   176,    56,   175,    -1,   176,     5,    56,
     119,   171,   120,    -1,   176,    56,   119,   171,   120,    -1,
     182,    -1,   171,   118,   182,    -1,   176,     7,   173,   175,
      -1,   176,     6,   173,   175,    -1,    23,    -1,    20,    -1,
      85,    -1,     5,    45,   175,    -1,    45,   175,    -1,   119,
     150,   120,    -1,   176,     8,   176,    -1,   176,     9,   176,
      -1,   176,    10,   176,    -1,   176,    11,   176,    -1,   176,
      12,   176,    -1,   176,    13,   176,    -1,     8,   176,    -1,
       9,   176,    -1,   182,    -1,   189,    -1,   183,    -1,   184,
      -1,   119,   176,   120,    -1,   178,    -1,   177,   118,   178,
      -1,   176,    -1,   176,    24,   180,    -1,    15,    -1,    15,
      -1,    15,    -1,   185,    -1,    21,   119,    10,   120,    -1,
     173,   119,   176,   120,    -1,    21,   119,    42,   189,   120,
      -1,    21,   119,    20,   176,   120,    -1,    21,   119,   176,
     120,    -1,    21,   119,   184,   120,    -1,    22,   119,   176,
     118,   176,   120,    -1,    16,    -1,     8,    18,    -1,     9,
      18,    -1,    18,    -1,     8,    19,    -1,     9,    19,    -1,
      19,    -1,   187,    -1,   121,    -1,    11,    -1,    15,    -1,
      17,    -1,   187,    -1,   190,   191,    -1,    15,    -1,   188,
     121,    15,    -1,   188,   122,    15,    -1,    -1,   123,    18,
     124,    -1,   123,   181,   124,    -1,    15,   191,    -1,   194,
      -1,   119,   193,   120,    -1,   158,   195,   199,   106,   158,
     196,    -1,    -1,   113,    -1,    -1,   197,    -1,   198,    -1,
      69,   163,    -1,   112,   119,   161,   120,    -1,    -1,   107,
      -1,   200,   201,    -1,   109,    -1,   110,    -1,   111,    -1,
      -1,   108,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   112,   112,   124,   125,   132,   133,   134,   135,   144,
     152,   153,   163,   187,   195,   204,   205,   210,   233,   256,
     257,   262,   264,   269,   270,   274,   275,   276,   280,   318,
     322,   323,   327,   328,   332,   333,   334,   338,   339,   343,
     344,   349,   354,   361,   362,   366,   367,   368,   372,   373,
     377,   378,   382,   389,   412,   441,   446,   451,   454,   458,
     473,   474,   478,   482,   486,   487,   491,   495,   496,   500,
     501,   505,   506,   512,   513,   514,   515,   516,   517,   521,
     522,   523,   524,   525,   526,   527,   531,   532,   533,   534,
     538,   539,   543,   544,   548,   549,   553,   554,   558,   559,
     560,   561,   565,   566,   570,   571,   575,   576,   577,   581,
     582,   586,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   610,   617,   627,   628,   632,
     636,   645,   654,   659,   660,   661,   662,   663,   664,   669,
     674,   675,   676,   677,   678,   679,   680,   686,   706,   707,
     708,   709,   713,   731,   739,   759,   784,   813,   814,   818,
     827,   866,   867,   871,   878,   879,   883,   884,   885,   889,
     893,   897,   898,   899,   903,   904,   905,   909,   910
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "OR", "AND", "NOT", "EQUAL",
  "COMPARISON", "'+'", "'-'", "'*'", "'/'", "'&'", "'|'", "UMINUS", "NAME",
  "STRING", "TNAME", "INTNUM", "APPROXNUM", "ALL", "AMMSC", "AMMSC2",
  "ANY", "AS", "ASC", "AUTHORIZATION", "BETWEEN", "BY", "CHARACTER",
  "CHECK", "CLOSE", "COMMIT", "CONTINUE", "CREATE", "CURRENT", "CURSOR",
  "DECIMAL", "DECLARE", "DEFAULT", "DELETE", "DESC", "DISTINCT", "DOUBLE",
  "ESCAPE", "EXISTS", "FETCH", "FLOAT", "FOR", "FOREIGN", "FOUND", "FROM",
  "GOTO", "GRANT", "GROUP", "HAVING", "IN", "INDICATOR", "INSERT",
  "INTEGER", "INTO", "IS", "KEY", "LANGUAGE", "LIKE", "MODULE", "NULLX",
  "NUMERIC", "OF", "ON", "OPEN", "OPTION", "ORDER", "PRECISION", "PRIMARY",
  "PRIVILEGES", "PROCEDURE", "PUBLIC", "REAL", "REFERENCES", "ROLLBACK",
  "SCHEMA", "SELECT", "SET", "SMALLINT", "SOME", "SQLCODE", "SQLERROR",
  "TABLE", "TO", "UNION", "UNIQUE", "UPDATE", "USER", "VALUES", "VIEW",
  "WHENEVER", "WHERE", "WITH", "WORK", "COBOL", "FORTRAN", "PASCAL", "PLI",
  "C", "ADA", "JOIN", "INNER", "OUTER", "LEFT", "RIGHT", "FULL", "USING",
  "NATURAL", "INDEX", "LIMIT", "OFFSET", "';'", "','", "'('", "')'", "'.'",
  "':'", "'['", "']'", "$accept", "sql", "semi", "manipulative_statement",
  "delete_statement_searched", "direct_select_statement",
  "insert_statement", "update_statement_searched", "column_commalist",
  "opt_column_commalist", "opt_order_by_clause", "ordering_spec_commalist",
  "ordering_spec", "opt_asc_desc", "values_or_query_spec",
  "insert_atom_commalist", "insert_atom", "opt_all_distinct",
  "assignment_commalist", "assignment", "opt_where_clause", "query_exp",
  "non_join_query_exp", "query_term", "non_join_query_term", "query_spec",
  "query_spec_first", "selection", "from_clause", "S_From", "E_From",
  "D_From", "table_ref_commalist", "table_ref", "where_clause",
  "opt_group_by_clause", "column_ref_commalist", "opt_having_clause",
  "search_condition", "predicate", "comparison_predicate",
  "between_predicate", "like_predicate", "opt_escape", "test_for_null",
  "in_predicate", "atom_commalist", "all_or_any_predicate", "any_all_some",
  "existence_test", "subquery", "scalar_exp", "scalar_exp_commalist",
  "scalar_exp_AS", "alias", "alias_column", "alias_column2", "atom",
  "function_ref", "function_ref2", "literal", "table", "path",
  "table_simple", "column_ref", "column_value", "opt_array", "column",
  "joined_table", "qualified_join", "opt_natural",
  "opt_join_specification", "join_condition", "named_columns_join",
  "opt_join_type", "outer_join_type", "opt_outer", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,    43,    45,
      42,    47,    38,   124,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    59,    44,    40,
      41,    46,    58,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   125,   126,   127,   127,   128,   128,   128,   128,   129,
     130,   130,   130,   131,   132,   133,   133,   134,   134,   135,
     135,   136,   136,   137,   137,   138,   138,   138,   139,   139,
     140,   140,   141,   141,   142,   142,   142,   143,   143,   144,
     144,   145,   145,   146,   146,   147,   147,   147,   148,   148,
     149,   149,   150,   151,   151,   152,   153,   154,   155,   156,
     157,   157,   158,   158,   158,   158,   159,   160,   160,   161,
     161,   162,   162,   163,   163,   163,   163,   163,   163,   164,
     164,   164,   164,   164,   164,   164,   165,   165,   165,   165,
     166,   166,   167,   167,   168,   168,   169,   169,   170,   170,
     170,   170,   171,   171,   172,   172,   173,   173,   173,   174,
     174,   175,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   177,   177,   178,   178,   179,
     180,   181,   182,   183,   183,   183,   183,   183,   183,   184,
     185,   185,   185,   185,   185,   185,   185,   186,   187,   187,
     187,   187,   188,   189,   190,   190,   190,   191,   191,   191,
     192,   193,   193,   194,   195,   195,   196,   196,   196,   197,
     198,   199,   199,   199,   200,   200,   200,   201,   201
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     1,     1,     1,     1,     1,     6,
       2,     4,     6,     7,     7,     1,     3,     0,     3,     0,
       3,     1,     3,     2,     2,     0,     1,     1,     4,     1,
       1,     3,     1,     1,     0,     1,     1,     1,     3,     3,
       3,     1,     2,     1,     1,     1,     3,     4,     1,     1,
       1,     3,     4,     4,     4,     1,     4,     0,     0,     0,
       1,     3,     1,     2,     1,     2,     2,     0,     3,     1,
       3,     0,     2,     0,     3,     3,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       6,     5,     5,     4,     0,     2,     4,     3,     4,     3,
       6,     5,     1,     3,     4,     4,     1,     1,     1,     3,
       2,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       1,     1,     1,     1,     3,     1,     3,     1,     3,     1,
       1,     1,     1,     4,     4,     5,     5,     4,     4,     6,
       1,     2,     2,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     3,     3,     0,     3,     3,
       2,     1,     3,     6,     0,     1,     0,     1,     1,     2,
       4,     0,     1,     2,     1,     1,     1,     0,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,   149,   150,   151,     0,     0,     0,    34,    57,     0,
     148,     0,     3,     5,     6,     7,     8,    19,    43,    45,
      50,    59,   164,     0,    62,   147,    64,   161,     0,    57,
      57,    35,    36,     0,     0,     0,    43,    64,     1,     4,
       2,     0,     0,    10,    67,    41,   165,   171,   130,    65,
     129,    63,     0,     0,   154,   140,   143,   146,   107,     0,
     106,   108,     0,     0,     0,   120,   122,   123,   132,   152,
       0,   121,   157,     0,     0,     0,     0,   127,    55,   125,
       0,   164,    64,    51,   162,     0,     0,    46,    48,    49,
       0,     0,    71,    73,    42,   172,   174,   175,   176,     0,
     177,   141,   144,   118,   142,   145,   119,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     153,   164,   164,    57,    54,    53,     0,     0,    64,     0,
      25,    20,    21,    25,    47,    11,     0,    73,    52,    73,
       0,    73,    66,    78,    79,    80,    81,    82,    83,    84,
      85,     0,   121,     0,   178,   173,     0,     0,     0,     0,
     123,   124,     0,   112,   113,   114,   115,   116,   117,     0,
     155,   156,   131,     0,     0,    59,    17,     0,   128,   126,
       0,    26,    27,    23,     0,    24,     0,    68,    69,    72,
       0,    76,     0,   110,     0,     0,    73,    73,     0,     0,
       0,     0,     0,     0,     0,   166,   133,     0,     0,   137,
     138,   134,   139,   158,   159,     9,     0,     0,    58,    60,
     157,    59,    37,     0,    22,    12,     0,   109,     0,    77,
      74,    75,     0,     0,     0,     0,     0,    89,    87,     0,
      88,    86,     0,     0,    99,     0,     0,    94,     0,    97,
      73,     0,   163,   167,   168,   136,   135,     0,    15,     0,
      13,    29,     0,    56,   160,     0,    14,     0,    70,   111,
       0,     0,    98,    94,     0,   105,   104,     0,     0,   102,
     141,   144,   142,   145,     0,    93,    96,   169,     0,     0,
      18,     0,    61,    38,    40,    39,     0,     0,    92,    91,
       0,   101,    95,     0,    16,    33,     0,    30,    32,    90,
     100,   103,   170,     0,    28,    31
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    11,    40,    12,    13,    14,    15,    16,   257,   217,
      43,   131,   132,   183,   260,   306,   307,    33,   221,   222,
      44,    17,    18,    87,    19,   228,    21,    76,   124,    34,
     129,    45,   218,    22,    94,    92,   187,   138,   142,   143,
     144,   145,   146,   285,   147,   148,   278,   149,    63,   150,
     193,   151,    78,    79,    51,    49,   174,    65,    66,    67,
      68,    24,    69,    70,    71,    72,   120,   223,    82,    27,
      47,   252,   253,   254,    99,   100,   155
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -213
static const yytype_int16 yypact[] =
{
      22,  -213,  -213,  -213,   -90,    -9,    -4,    -6,  -213,   184,
    -213,    53,   -43,  -213,  -213,  -213,  -213,   -41,  -213,  -213,
    -213,  -213,   -49,    87,    93,  -213,     6,  -213,   384,  -213,
    -213,  -213,  -213,   312,   342,    29,    13,   -82,  -213,  -213,
    -213,    97,   407,    30,   102,    80,  -213,    48,  -213,  -213,
    -213,  -213,   435,   464,    16,  -213,  -213,  -213,  -213,    64,
    -213,  -213,   384,    84,   200,  -213,  -213,  -213,  -213,  -213,
      40,  -213,    91,   342,   342,   154,   154,   557,   101,  -213,
     342,   -55,  -213,  -213,  -213,   117,   184,  -213,  -213,   385,
     208,   223,   210,   131,  -213,  -213,  -213,  -213,  -213,   161,
     169,  -213,  -213,  -213,  -213,  -213,  -213,   277,   156,   384,
     384,   384,   384,   384,   384,   384,   384,   265,   266,    28,
    -213,     9,   -47,  -213,  -213,  -213,    87,   384,   162,   207,
      35,   183,  -213,    35,  -213,   186,   100,   131,  -213,   170,
     185,   131,   193,  -213,  -213,  -213,  -213,  -213,  -213,  -213,
    -213,   530,   245,   342,  -213,  -213,   194,   384,   100,   222,
     196,  -213,   232,   505,   505,   211,   211,  -213,  -213,   261,
    -213,  -213,  -213,   201,   202,  -213,   205,   342,  -213,  -213,
     323,  -213,  -213,  -213,   117,  -213,   322,   236,  -213,   193,
     185,  -213,   259,  -213,     7,   251,   131,   131,     5,   491,
     491,   384,   237,   209,     2,   495,  -213,   300,   238,  -213,
    -213,  -213,  -213,  -213,  -213,  -213,   323,    11,   242,   482,
      91,   249,  -213,   363,  -213,  -213,   100,  -213,   243,  -213,
     366,  -213,   384,   264,   209,   328,   289,  -213,   605,   289,
    -213,   605,   378,   515,  -213,   218,   229,   340,   319,  -213,
     131,   290,  -213,  -213,  -213,  -213,  -213,  -100,  -213,   292,
    -213,  -213,   342,  -213,  -213,   323,  -213,   357,  -213,  -213,
     426,   515,  -213,   340,   328,  -213,  -213,   384,   -53,  -213,
    -213,  -213,  -213,  -213,   209,  -213,  -213,   193,   100,   323,
    -213,   543,   482,  -213,  -213,   605,   384,   -20,  -213,   605,
     209,  -213,  -213,    62,  -213,  -213,    82,  -213,  -213,   605,
    -213,  -213,  -213,   543,  -213,  -213
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -213,  -213,  -213,  -213,  -213,  -213,  -213,  -213,  -213,  -213,
    -213,  -213,   228,   281,  -213,  -213,    81,  -213,  -213,   150,
    -173,   408,   410,   335,   -29,     3,  -213,  -213,   356,    -7,
    -106,  -213,  -213,   -33,  -213,  -213,   152,  -213,   -87,  -213,
    -213,  -213,  -213,   168,  -213,  -213,   174,  -213,    54,  -213,
     226,   -28,  -213,   321,  -213,   334,  -213,   287,  -213,    17,
    -213,  -213,    21,  -213,   -66,  -213,   244,  -212,   275,  -213,
    -213,  -213,  -213,  -213,  -213,  -213,  -213
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -165
static const yytype_int16 yytable[] =
{
      64,    81,   215,    20,   258,    77,   -44,   248,   -44,   -58,
     196,   197,    20,    88,    31,   175,   176,    23,   289,   133,
     290,    25,    73,    74,   103,   106,    23,   152,   -58,    28,
      25,    41,   232,     1,   108,   -58,    32,     2,    84,     3,
     121,   122,    29,   172,     4,    20,   173,   -58,   266,    42,
     189,    23,   191,    38,   194,    25,    30,    88,    46,    23,
     181,   233,     5,    25,    46,   300,    46,   301,   249,   234,
     188,   152,   -58,   152,    39,   152,   182,   304,   -44,   159,
       6,   162,   163,   164,   165,   166,   167,   168,   169,    20,
      23,    23,   208,     7,    25,    25,   -44,    23,   300,    77,
     310,    25,    48,    23,     7,   259,   -58,    25,    50,   230,
     231,     1,   263,   195,     8,    54,   177,     3,   133,    42,
     205,   -44,    46,   -44,   160,    85,   -58,   229,     1,   207,
     152,   152,    54,    83,     3,   130,   139,  -150,  -150,    52,
      53,     9,     1,    10,   219,    90,    54,    55,     3,    56,
      57,    58,    59,     4,    60,    95,    91,    96,    97,    98,
     268,   117,   118,   287,   110,   111,   112,   113,   114,   115,
      23,   238,   241,   242,    25,   139,   140,    93,    52,    53,
     226,     1,   312,   107,   152,    54,    55,     3,    56,    57,
      58,    59,     4,    60,    23,     1,   196,   197,    25,     2,
     313,     3,   314,   109,   270,   123,     4,   108,   110,   111,
     112,   113,   114,   115,   119,   190,    61,   245,   246,   127,
     261,    10,   188,   114,   115,    55,   135,    56,    57,   292,
     110,   111,   112,   113,   114,   115,   280,   281,    10,   295,
     110,   111,   112,   113,   114,   115,   162,   282,   283,   299,
     141,   136,    10,   236,   239,    61,   198,   199,   200,   110,
     111,   112,   113,   114,   115,   137,     7,   153,   309,   110,
     111,   112,   113,   114,   115,    26,   161,   154,   201,    23,
     170,   171,    84,    25,    37,    52,    53,   156,     1,   141,
     180,    10,    54,    55,     3,    56,    57,   157,    59,     4,
      60,   184,   186,     9,   192,    10,   204,   202,   110,   111,
     112,   113,   114,   115,   206,   203,   210,    89,   116,   158,
      52,    53,    75,     1,   216,   213,   214,    54,    55,     3,
      56,    57,    58,    59,     4,    60,    52,    53,   220,     1,
     225,     7,   209,    54,    55,     3,    56,    57,    58,    59,
       4,    60,   211,     1,   226,   128,   243,     2,   256,     3,
     262,    89,    61,   269,     4,    52,    53,   265,     1,   267,
     197,   161,    54,    55,     3,    56,    57,    58,    59,     4,
      60,   212,   277,   271,   284,   286,   110,   111,   112,   113,
     114,   115,    52,    53,   315,     1,    62,    61,    10,    54,
      55,     3,    56,    57,    58,    59,     4,    60,   274,   288,
       7,   291,   224,    61,   185,   293,   227,    35,     1,    36,
     255,   134,     2,   294,     3,   237,   240,    86,   244,     4,
     296,    62,   125,    10,   110,   111,   112,   113,   114,   115,
     303,   298,    61,    52,    53,   297,     1,    62,   179,    10,
      54,    55,     3,   101,   102,    58,    59,     4,    60,   272,
     178,    80,   275,    10,   264,   276,     0,     0,     0,    61,
       0,     0,    52,    53,     0,     1,    62,     0,    10,    54,
      55,     3,   104,   105,    58,    59,     4,    60,     0,     7,
     247,   -64,   -64,     0,   -64,   -64,   -64,     0,   -64,    52,
      53,     0,     1,    62,     0,    10,    54,    55,     3,    56,
      57,    58,    59,     4,    60,   112,   113,   114,   115,     0,
      61,   273,     0,   245,   246,     0,     9,     0,    10,     0,
     279,    55,     0,    56,    57,   198,   199,   200,   110,   111,
     112,   113,   114,   115,     0,     0,     0,     0,     0,    61,
       0,   245,   246,     0,    62,     0,    10,   201,   279,    55,
       0,    56,    57,     0,   250,   110,   111,   112,   113,   114,
     115,   302,     0,     0,     0,     0,    61,     0,   308,     0,
       0,   126,     0,    62,     0,    10,   202,   311,  -164,  -164,
       0,  -164,  -164,  -164,   203,    46,     0,     7,     0,     0,
     308,  -164,  -164,     0,  -164,  -164,  -164,   251,    46,   305,
     235,     0,    10,   110,   111,   112,   113,   114,   115
};

static const yytype_int16 yycheck[] =
{
      28,    34,   175,     0,   216,    33,     0,     5,    90,     0,
       3,     4,     9,    42,    20,   121,   122,     0,   118,    85,
     120,     0,    29,    30,    52,    53,     9,    93,    83,   119,
       9,    72,    27,    11,    62,    82,    42,    15,   120,    17,
      73,    74,    51,    15,    22,    42,    18,    94,   221,    90,
     137,    34,   139,     0,   141,    34,    60,    86,   113,    42,
      25,    56,    40,    42,   113,   118,   113,   120,    66,    64,
     136,   137,   119,   139,   117,   141,    41,   289,    72,   107,
      58,   109,   110,   111,   112,   113,   114,   115,   116,    86,
      73,    74,   158,    82,    73,    74,    90,    80,   118,   127,
     120,    80,    15,    86,    82,    94,    97,    86,    15,   196,
     197,    11,   218,   141,    92,    15,   123,    17,   184,    90,
     153,   115,   113,   117,   107,    28,   117,   120,    11,   157,
     196,   197,    15,   120,    17,    18,     5,   121,   122,     8,
       9,   119,    11,   121,   177,   115,    15,    16,    17,    18,
      19,    20,    21,    22,    23,   107,    54,   109,   110,   111,
     226,   121,   122,   250,     8,     9,    10,    11,    12,    13,
     153,   199,   200,   201,   153,     5,    45,    97,     8,     9,
     118,    11,   120,   119,   250,    15,    16,    17,    18,    19,
      20,    21,    22,    23,   177,    11,     3,     4,   177,    15,
     118,    17,   120,   119,   232,    51,    22,   235,     8,     9,
      10,    11,    12,    13,   123,    45,    85,     8,     9,   118,
     217,   121,   288,    12,    13,    16,    18,    18,    19,   262,
       8,     9,    10,    11,    12,    13,    18,    19,   121,   267,
       8,     9,    10,    11,    12,    13,   274,    18,    19,   277,
     119,    28,   121,   199,   200,    85,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    55,    82,   106,   296,     8,
       9,    10,    11,    12,    13,     0,   120,   108,    27,   262,
      15,    15,   120,   262,     9,     8,     9,    10,    11,   119,
      83,   121,    15,    16,    17,    18,    19,    20,    21,    22,
      23,   118,   116,   119,   119,   121,    61,    56,     8,     9,
      10,    11,    12,    13,   120,    64,   120,    42,   118,    42,
       8,     9,    10,    11,   119,   124,   124,    15,    16,    17,
      18,    19,    20,    21,    22,    23,     8,     9,    15,    11,
      18,    82,   120,    15,    16,    17,    18,    19,    20,    21,
      22,    23,   120,    11,   118,    80,   119,    15,   120,    17,
     118,    86,    85,   120,    22,     8,     9,   118,    11,     6,
       4,   120,    15,    16,    17,    18,    19,    20,    21,    22,
      23,   120,     4,   119,    44,    66,     8,     9,    10,    11,
      12,    13,     8,     9,   313,    11,   119,    85,   121,    15,
      16,    17,    18,    19,    20,    21,    22,    23,   119,   119,
      82,   119,   184,    85,   133,   265,   190,     9,    11,     9,
     120,    86,    15,    66,    17,   199,   200,    20,   202,    22,
       4,   119,    76,   121,     8,     9,    10,    11,    12,    13,
     288,   273,    85,     8,     9,   271,    11,   119,   127,   121,
      15,    16,    17,    18,    19,    20,    21,    22,    23,   233,
     126,   119,   236,   121,   220,   239,    -1,    -1,    -1,    85,
      -1,    -1,     8,     9,    -1,    11,   119,    -1,   121,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    -1,    82,
     203,   106,   107,    -1,   109,   110,   111,    -1,   113,     8,
       9,    -1,    11,   119,    -1,   121,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    10,    11,    12,    13,    -1,
      85,   234,    -1,     8,     9,    -1,   119,    -1,   121,    -1,
     243,    16,    -1,    18,    19,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,    85,
      -1,     8,     9,    -1,   119,    -1,   121,    27,   271,    16,
      -1,    18,    19,    -1,    69,     8,     9,    10,    11,    12,
      13,   284,    -1,    -1,    -1,    -1,    85,    -1,   291,    -1,
      -1,    24,    -1,   119,    -1,   121,    56,   300,   106,   107,
      -1,   109,   110,   111,    64,   113,    -1,    82,    -1,    -1,
     313,   106,   107,    -1,   109,   110,   111,   112,   113,    66,
     119,    -1,   121,     8,     9,    10,    11,    12,    13
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    11,    15,    17,    22,    40,    58,    82,    92,   119,
     121,   126,   128,   129,   130,   131,   132,   146,   147,   149,
     150,   151,   158,   184,   186,   187,   193,   194,   119,    51,
      60,    20,    42,   142,   154,   146,   147,   193,     0,   117,
     127,    72,    90,   135,   145,   156,   113,   195,    15,   180,
      15,   179,     8,     9,    15,    16,    18,    19,    20,    21,
      23,    85,   119,   173,   176,   182,   183,   184,   185,   187,
     188,   189,   190,   154,   154,    10,   152,   176,   177,   178,
     119,   158,   193,   120,   120,    28,    20,   148,   149,   193,
     115,    54,   160,    97,   159,   107,   109,   110,   111,   199,
     200,    18,    19,   176,    18,    19,   176,   119,   176,   119,
       8,     9,    10,    11,    12,    13,   118,   121,   122,   123,
     191,   158,   158,    51,   153,   153,    24,   118,   193,   155,
      18,   136,   137,   189,   148,    18,    28,    55,   162,     5,
      45,   119,   163,   164,   165,   166,   167,   169,   170,   172,
     174,   176,   189,   106,   108,   201,    10,    20,    42,   176,
     184,   120,   176,   176,   176,   176,   176,   176,   176,   176,
      15,    15,    15,    18,   181,   155,   155,   154,   180,   178,
      83,    25,    41,   138,   118,   138,   116,   161,   189,   163,
      45,   163,   119,   175,   163,   176,     3,     4,     5,     6,
       7,    27,    56,    64,    61,   158,   120,   176,   189,   120,
     120,   120,   120,   124,   124,   145,   119,   134,   157,   158,
      15,   143,   144,   192,   137,    18,   118,   175,   150,   120,
     163,   163,    27,    56,    64,   119,   173,   175,   176,   173,
     175,   176,   176,   119,   175,     8,     9,   182,     5,    66,
      69,   112,   196,   197,   198,   120,   120,   133,   192,    94,
     139,   150,   118,   155,   191,   118,   145,     6,   189,   120,
     176,   119,   175,   182,   119,   175,   175,     4,   171,   182,
      18,    19,    18,    19,    44,   168,    66,   163,   119,   118,
     120,   119,   158,   144,    66,   176,     4,   171,   168,   176,
     118,   120,   182,   161,   192,    66,   140,   141,   182,   176,
     120,   182,   120,   118,   120,   141
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 112 "amga_sql_yacc.y++"
    { 
		free((yyvsp[(2) - (2)]));
		/* if there was no error,                   */
                /*   parseResult is set to the parsed query */
		if(_ASP->parseResult == NULL) {
		   _ASP->processPlainTable(_ASP->isPlain , (yyvsp[(1) - (2)]));
		   _ASP->parseResult= (yyvsp[(1) - (2)]) ; 
		}
	;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 124 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 125 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 132 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 133 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 134 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 135 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 145 "amga_sql_yacc.y++"
    { 
			__C6((yyval),(yyvsp[(1) - (6)]),(yyvsp[(2) - (6)]),(yyvsp[(3) - (6)]),(yyvsp[(4) - (6)]),(yyvsp[(5) - (6)]),(yyvsp[(6) - (6)])) 
		;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 152 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 153 "amga_sql_yacc.y++"
    { 
                  if( !strcmp(_ASP->mdserver->dbHelper->backend(),"Oracle")){
                    char* s1 = strdup("select * from (");
                    char* s2 = strdup(") donotusethisalias where rownum <=");
		    __C5((yyval),s1,(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),s2,(yyvsp[(4) - (4)])) ;
                    free((yyvsp[(3) - (4)]));
                  } else {
		    __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) 
                  }
		;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 163 "amga_sql_yacc.y++"
    { 
                  if( !strcmp(_ASP->mdserver->dbHelper->backend(),"Oracle")){
                    char* s1 = strdup("select * from (");
                    char* s2 = strdup(") donotusethisalias where rownum <=");
                    char* s4;
                    { __C4(s4,s1,(yyvsp[(1) - (6)]),(yyvsp[(2) - (6)]),s2); }
                    char* s5 = strdup(s4);
                    char* s6 = strdup("minus");
                    char* s7 = strdup((yyvsp[(6) - (6)]));
                    char* s8 = strdup("+");
		    { __C7((yyval),s4,(yyvsp[(6) - (6)]),s8,(yyvsp[(4) - (6)]),s6,s5,s7) ; }
                    free((yyvsp[(3) - (6)])); free((yyvsp[(5) - (6)]));
                  } else {
		    __C6((yyval),(yyvsp[(1) - (6)]),(yyvsp[(2) - (6)]),(yyvsp[(3) - (6)]),(yyvsp[(4) - (6)]),(yyvsp[(5) - (6)]),(yyvsp[(6) - (6)])) 
                  }
		;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 188 "amga_sql_yacc.y++"
    { 
			__C7((yyval),(yyvsp[(1) - (7)]),(yyvsp[(2) - (7)]),(yyvsp[(3) - (7)]),(yyvsp[(4) - (7)]),(yyvsp[(5) - (7)]),(yyvsp[(6) - (7)]),(yyvsp[(7) - (7)])) 
		;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 196 "amga_sql_yacc.y++"
    { 
			__C7((yyval),(yyvsp[(1) - (7)]),(yyvsp[(2) - (7)]),(yyvsp[(3) - (7)]),(yyvsp[(4) - (7)]),(yyvsp[(5) - (7)]),(yyvsp[(6) - (7)]),(yyvsp[(7) - (7)])) 
		;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 204 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 205 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 210 "amga_sql_yacc.y++"
    { 
                        if( _ASP->error ==  ER_NO_ERROR ) {
			   /* get all the column names */
                           std::string column;
			   column.append("(");
                           int ret = getAllColumn(_ASP, column, true);
			   column.append(")");

                           /* make FILE be filled mandatorily */
                           _ASP->hasFILE = 1;

                           if ( ret != 0 ) {
                                _ASP->error = ER_FAIL_GET_COLUMN_NAME;
                                _ASP->parseResult = strdup("Fail to Get Column Name");
			        __C0((yyval)) 
                           } else {
                             (yyval) = strdup (column.c_str() ) ;
                           }
                        } else {
			   __C0((yyval)) 
                        }

		;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 234 "amga_sql_yacc.y++"
    { 
			if( _ASP->isPlain == 0) {
                          std::string str;
                          if (_ASP->hasFILE == 0 ) 
			    str.append("\"file\",");
                          if (_ASP->hasOWNER == 0 ) 
			    str.append("\"owner\",");
                          if (_ASP->hasPERM == 0 ) 
			    str.append("\"permissions\",");
                          if (_ASP->hasGROUP == 0 ) 
			    str.append("\"group_rights\",");
                          char* k = strdup( str.c_str());
			  __C4((yyval),(yyvsp[(1) - (3)]),k,(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) 
			} else {
			  __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) 
			}
		;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 256 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 258 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 263 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 265 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 269 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 270 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 274 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 275 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 276 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 281 "amga_sql_yacc.y++"
    { 
                  /* If target tables are not plain */
                  if( _ASP->isPlain == 0) {
                    std::string str;
                    /* If the given query does not include FILE keyword */
                    if ( _ASP->hasFILE == 0 ) {
		      /* generate random string for a file */
		      std::string guid = AMGA::validateGUID("gen");
		      int len = guid.size();
                      char* k1 = strdup(guid.c_str());
		      k1[0] = '\'';
		      k1[len-1] = '\'';
                      str.append(k1);
                      free(k1);
                      str.append(",");
                    }
                    if ( _ASP->hasOWNER == 0 ) {
                      str.append("'");
                      str.append(_ASP->mdserver->getUser());
                      str.append("',");
                    }
                    if ( _ASP->hasPERM == 0 ) {
                      str.append("'");
                      str.append(_ASP->mdserver->getPermissionMask());
                      str.append("',");
                    }
                    if ( _ASP->hasGROUP == 0 ) {
                      str.append("'");
                      str.append(_ASP->mdserver->getGroupRightsMask());
                      str.append("',");
                    }
                    char* k2 = strdup(str.c_str());
		    __C5((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),k2,(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) 
		  } else {
		    __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) 
		  }
		;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 318 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 322 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 323 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 327 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 328 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 332 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 333 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 334 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 338 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 339 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 343 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 344 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 350 "amga_sql_yacc.y++"
    { 
                  char *k = strdup("WHERE (1=1)");
                  __C2((yyval),k,(yyvsp[(1) - (1)])) 
                ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 355 "amga_sql_yacc.y++"
    { 
                  __C2((yyval),(yyvsp[(2) - (2)]),(yyvsp[(1) - (2)]))  
                ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 361 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 362 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 366 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 367 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 368 "amga_sql_yacc.y++"
    { __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 372 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 373 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 377 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 378 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 383 "amga_sql_yacc.y++"
    {
			__C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) 
		;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 390 "amga_sql_yacc.y++"
    { 
		  _ASP->stopCountColumn() ;
                  if ( ( _ASP->sqlType == MDInterpreter::cINSERT ) &&
                       ( _ASP->isPlain == 0 ) ) {
                    std::string str;
                    /* to retrieve a file column           */
                    /*     in addition to all user columns */
                    if (_ASP->hasFILE == 0 )
                      str.append("\"file\",");
                    if (_ASP->hasOWNER == 0 )
                      str.append("\"owner\",");
                    if (_ASP->hasPERM == 0 )
                      str.append("\"permissions\",");
                    if (_ASP->hasGROUP == 0 )
                      str.append("\"group_rights\",");
                    char* k1 = strdup( str.c_str());

                    __C5((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),k1,(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)]))
                  } else {
                    __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)]))
                  }
		;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 413 "amga_sql_yacc.y++"
    { 
	  	  if( _ASP->error ==  ER_NO_ERROR ) {
                    std::string column;
                    int ret;
                    if ( _ASP->sqlType == MDInterpreter::cINSERT ) {
                      ret = getAllColumn(_ASP, column, true);
                    } else {
                      ret = getAllColumn(_ASP, column, false);
                    }

		    _ASP->stopCountColumn() ;

                    if ( ret != 0 ) {
                      free((yyvsp[(2) - (4)])); free((yyvsp[(3) - (4)])); free((yyvsp[(4) - (4)])); __C1((yyval),(yyvsp[(1) - (4)]))
                       _ASP->error = ER_FAIL_GET_COLUMN_NAME;
                       _ASP->parseResult = strdup("Fail to Get Column Name");
                    } else {
                      char *s1 = strdup (column.c_str() ) ;
                      free((yyvsp[(3) - (4)]));
                      __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),s1,(yyvsp[(4) - (4)]))
                    }
                   } else {
                     free((yyvsp[(2) - (4)])); free((yyvsp[(3) - (4)])); free((yyvsp[(4) - (4)])); __C1((yyval),(yyvsp[(1) - (4)]))
                  }
		;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 441 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 447 "amga_sql_yacc.y++"
    { __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 451 "amga_sql_yacc.y++"
    { _ASP->startFromClause(); __C0((yyval)); ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 454 "amga_sql_yacc.y++"
    { _ASP->stopFromClause(); __C0((yyval)); ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 458 "amga_sql_yacc.y++"
    { 
                  char *k2;
                  if(_ASP->sticky){
                    k2 = fillPermission(_ASP, 'a');
                  } else if(_ASP->sqlType == MDInterpreter::cSELECT){
                    k2 = fillPermission(_ASP, 'r');
                  } else {
                    k2 = fillPermission(_ASP, 'w');
                  }
                  _ASP->destroyFromClause();   
                  __C1((yyval),k2); 
                ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 473 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 474 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 478 "amga_sql_yacc.y++"
    { 
				  _ASP->insertFromClause(_ASP->tmpReferTable,(yyvsp[(1) - (1)]),"",_ASP->tmpReferFlags); 
				  __C1((yyval),(yyvsp[(1) - (1)])) 
				;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 482 "amga_sql_yacc.y++"
    { 
				  _ASP->insertFromClause(_ASP->tmpReferTable,(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)]),_ASP->tmpReferFlags); 
				  __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) 
				;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 486 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 487 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 491 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 495 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 496 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 500 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 501 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 505 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 506 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 512 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 513 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 514 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 515 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 516 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 517 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 521 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 522 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 523 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 524 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 525 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 526 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 527 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 531 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 532 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 533 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 534 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 538 "amga_sql_yacc.y++"
    { __C6((yyval),(yyvsp[(1) - (6)]),(yyvsp[(2) - (6)]),(yyvsp[(3) - (6)]),(yyvsp[(4) - (6)]),(yyvsp[(5) - (6)]),(yyvsp[(6) - (6)])) ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 539 "amga_sql_yacc.y++"
    { __C5((yyval),(yyvsp[(1) - (5)]),(yyvsp[(2) - (5)]),(yyvsp[(3) - (5)]),(yyvsp[(4) - (5)]),(yyvsp[(5) - (5)])) ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 543 "amga_sql_yacc.y++"
    { __C5((yyval),(yyvsp[(1) - (5)]),(yyvsp[(2) - (5)]),(yyvsp[(3) - (5)]),(yyvsp[(4) - (5)]),(yyvsp[(5) - (5)])) ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 544 "amga_sql_yacc.y++"
    { __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 548 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 549 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 553 "amga_sql_yacc.y++"
    { __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) ;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 554 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 558 "amga_sql_yacc.y++"
    { __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 559 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 560 "amga_sql_yacc.y++"
    { __C6((yyval),(yyvsp[(1) - (6)]),(yyvsp[(2) - (6)]),(yyvsp[(3) - (6)]),(yyvsp[(4) - (6)]),(yyvsp[(5) - (6)]),(yyvsp[(6) - (6)])) ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 561 "amga_sql_yacc.y++"
    { __C5((yyval),(yyvsp[(1) - (5)]),(yyvsp[(2) - (5)]),(yyvsp[(3) - (5)]),(yyvsp[(4) - (5)]),(yyvsp[(5) - (5)])) ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 565 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 566 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 570 "amga_sql_yacc.y++"
    { __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 571 "amga_sql_yacc.y++"
    { __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 575 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 576 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 577 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 581 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 582 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 586 "amga_sql_yacc.y++"
    { 
			__C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) 
		;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 594 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); __A1("Column"); ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 595 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); __A1("Column"); ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 596 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); __A1("Column"); ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 597 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); __A1("Column"); ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 598 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); __A1("Column"); ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 599 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); __A1("Column"); ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 600 "amga_sql_yacc.y++"
    { __B2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)]));    __A1("Column"); ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 601 "amga_sql_yacc.y++"
    { __B2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)]));    __A1("Column"); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 602 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)]));       __A1("Column"); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 603 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)]));       ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 604 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)]));       ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 605 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)]));       ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 606 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 610 "amga_sql_yacc.y++"
    { 
			if (_ASP->countingColumn() ) {
                          _ASP->numColumn += 1;
                          _ASP->usedAttr.insert( TAttribute(_ASP->numColumn, _ASP->tmpReferAttr));
                        }
	  		__C1((yyval),(yyvsp[(1) - (1)])) 
		;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 617 "amga_sql_yacc.y++"
    {
			if (_ASP->countingColumn() ) {
                          _ASP->numColumn += 1;
                          _ASP->usedAttr.insert( TAttribute(_ASP->numColumn, _ASP->tmpReferAttr));
                        }
			__C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) 
		;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 627 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 628 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])); ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 632 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 636 "amga_sql_yacc.y++"
    { 
                          __A1((yyvsp[(1) - (1)]));
                          char* s1 = strdup(USER_STRING);
                          char* s2 = strdup("$");
                          __B3((yyval),s1,(yyvsp[(1) - (1)]),s2)
		;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 645 "amga_sql_yacc.y++"
    {
                          char* s1 = strdup(USER_STRING);
                          char* s2 = strdup("$");
                          __B3((yyval),s1,(yyvsp[(1) - (1)]),s2)
                ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 654 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 659 "amga_sql_yacc.y++"
    { __A1((yyvsp[(1) - (4)])); __B4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])); ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 660 "amga_sql_yacc.y++"
    { __A1((yyvsp[(1) - (4)])); __B4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])); ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 661 "amga_sql_yacc.y++"
    { __A1((yyvsp[(1) - (5)])); __B5((yyval),(yyvsp[(1) - (5)]),(yyvsp[(2) - (5)]),(yyvsp[(3) - (5)]),(yyvsp[(4) - (5)]),(yyvsp[(5) - (5)])); ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 662 "amga_sql_yacc.y++"
    { __A1((yyvsp[(1) - (5)])); __B5((yyval),(yyvsp[(1) - (5)]),(yyvsp[(2) - (5)]),(yyvsp[(3) - (5)]),(yyvsp[(4) - (5)]),(yyvsp[(5) - (5)])); ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 663 "amga_sql_yacc.y++"
    { __A1((yyvsp[(1) - (4)])); __B4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])); ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 664 "amga_sql_yacc.y++"
    { __A1((yyvsp[(1) - (4)])); __B4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])); ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 669 "amga_sql_yacc.y++"
    { __C6((yyval),(yyvsp[(1) - (6)]),(yyvsp[(2) - (6)]),(yyvsp[(3) - (6)]),(yyvsp[(4) - (6)]),(yyvsp[(5) - (6)]),(yyvsp[(6) - (6)])); ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 674 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 675 "amga_sql_yacc.y++"
    { __B2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 676 "amga_sql_yacc.y++"
    { __B2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 677 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 678 "amga_sql_yacc.y++"
    { __B2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 679 "amga_sql_yacc.y++"
    { __B2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 680 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 686 "amga_sql_yacc.y++"
    {
                      if( _ASP->error !=  ER_NO_ERROR )  {
                           __C1((yyval),(yyvsp[(1) - (1)]))
                      } else {
                        std::string result;
                        std::string table = (yyvsp[(1) - (1)]);
  DMESG("processTable Name : " << table << std::endl);
                        int ret = processTable(_ASP,table,false,true,result);
                        if ( ret != 0 ) {
                          __C1((yyval),(yyvsp[(1) - (1)]))
                        } else {
                          free((yyvsp[(1) - (1)]));
                          (yyval) = strdup( result.c_str() );
                        }
                     }
                ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 706 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 707 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 708 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 709 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 713 "amga_sql_yacc.y++"
    {
                      if( _ASP->error !=  ER_NO_ERROR )  {
                           __C1((yyval),(yyvsp[(1) - (1)]))
                      } else {
                        std::string result;
                        std::string table = (yyvsp[(1) - (1)]);
                        int ret = processTable(_ASP,table,true,false,result);
                        if ( ret != 0 ) {
                          __C1((yyval),(yyvsp[(1) - (1)]))
                        } else {
                          free((yyvsp[(1) - (1)]));
                          (yyval) = strdup( result.c_str() );
                        }
                     }
                ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 731 "amga_sql_yacc.y++"
    { 
			__B2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])); 
			;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 739 "amga_sql_yacc.y++"
    { 
                          __A1((yyvsp[(1) - (1)]));                          
                          if(  strncmp((yyvsp[(1) - (1)]),"FILE",4) == 0 ) {
                            char* s1 = strdup("\"file\"");
                            __C1((yyval),s1); free((yyvsp[(1) - (1)]));
                          } else if ( strncmp((yyvsp[(1) - (1)]),"PERMISSIONS",11) == 0 ) {
                            char* s1 = strdup("\"permissions\"");
                            __C1((yyval),s1); free((yyvsp[(1) - (1)]));
                          } else if ( strncmp((yyvsp[(1) - (1)]),"GROUP_RIGHTS",12) == 0 ) {
                            char* s1 = strdup("\"group_rights\"");
                            __C1((yyval),s1); free((yyvsp[(1) - (1)]));
                          } else if ( strncmp((yyvsp[(1) - (1)]),"OWNER",5) == 0 ) {
                            char* s1 = strdup("\"owner\"");
                            __C1((yyval),s1); free((yyvsp[(1) - (1)]));
                          } else {
			    char* s1 = strdup(USER_STRING);
			    char* s2 = strdup("$");
			    __B3((yyval),s1,(yyvsp[(1) - (1)]),s2) 
                          }
                        ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 759 "amga_sql_yacc.y++"
    { 
                          if( _ASP->countingColumn() ) {
                            _ASP->tmpReferAttr = _ASP->tmpReferTable + "." + (yyvsp[(3) - (3)]);      
                          }
                          if( strncmp((yyvsp[(3) - (3)]),"FILE",4) == 0 ) {
                            char* s1 = strdup("\"file\"");
                            __B3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),s1); free((yyvsp[(3) - (3)]));
                          } else if ( strncmp((yyvsp[(3) - (3)]),"PERMISSIONS",11) == 0 ) {
                            char* s1 = strdup("\"permissions\"");
                            __B3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),s1); free((yyvsp[(3) - (3)]));
                          } else if ( strncmp((yyvsp[(3) - (3)]),"GROUP_RIGHTS",12) == 0 ) {
                            char* s1 = strdup("\"group_rights\"");
                            __B3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),s1); free((yyvsp[(3) - (3)]));
                          } else if ( strncmp((yyvsp[(3) - (3)]),"OWNER",5) == 0 )  {
                            char* s1 = strdup("\"owner\"");
                            __B3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),s1); free((yyvsp[(3) - (3)]));
                          } else {
		 	    char* s1 = strdup(USER_STRING);
                            char* s2 = strdup("$");
			    char* s3;
			    __B3(s3,s1,(yyvsp[(3) - (3)]),s2) 
			    __B3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),s3) 
                          }

 			;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 784 "amga_sql_yacc.y++"
    { 
                          if( _ASP->countingColumn() ) {
                            _ASP->tmpReferAttr = _ASP->tmpReferTable + "." + (yyvsp[(3) - (3)]);      
                          }
			  free((yyvsp[(2) - (3)]));	
                          if( strncmp((yyvsp[(3) - (3)]),"FILE",4) == 0 ) {
                            char* s1 = strdup(".\"file\"");
                            __B2((yyval),(yyvsp[(1) - (3)]),s1); free((yyvsp[(3) - (3)]));
                          } else if ( strncmp((yyvsp[(3) - (3)]),"PERMISSIONS",11) == 0 ) {
                            char* s1 = strdup(".\"permissions\"");
                            __B2((yyval),(yyvsp[(1) - (3)]),s1); free((yyvsp[(3) - (3)]));
                          } else if ( strncmp((yyvsp[(3) - (3)]),"GROUP_RIGHTS",12) == 0 ) {
                            char* s1 = strdup(".\"group_rights\"");
                            __B2((yyval),(yyvsp[(1) - (3)]),s1); free((yyvsp[(3) - (3)]));
                          } else if ( strncmp((yyvsp[(3) - (3)]),"OWNER",5) == 0 ) {
                            char* s1 = strdup(".\"owner\"");
                            __B2((yyval),(yyvsp[(1) - (3)]),s1); free((yyvsp[(3) - (3)]));
                          } else {
                            char* s1 = strdup(USER_STRING);
                            char* s2 = strdup("$");
                            char* s3;
                            char* s4 = strdup(".");
                            __B4(s3,s4,s1,(yyvsp[(3) - (3)]),s2)
                            __B2((yyval),(yyvsp[(1) - (3)]),s3) 
                          }
			;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 813 "amga_sql_yacc.y++"
    { __C0((yyval)); ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 814 "amga_sql_yacc.y++"
    { 
                        _ASP->tmpReferAttr = _ASP->tmpReferAttr + (yyvsp[(1) - (3)]) + (yyvsp[(2) - (3)]) + (yyvsp[(3) - (3)]);      
			__B3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) 
		;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 818 "amga_sql_yacc.y++"
    { 
                        _ASP->tmpReferAttr = _ASP->tmpReferAttr + (yyvsp[(1) - (3)]) + (yyvsp[(3) - (3)]);      
			__B3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) 
		;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 827 "amga_sql_yacc.y++"
    { 
			  if( _ASP->isPlain ) {
			    __B2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)]))
			  } else if ( strncmp((yyvsp[(1) - (2)]),"FILE",4) == 0 ) {
                            char* s1 = strdup("\"file\"");
			    __C1((yyval),s1)
                            _ASP->hasFILE = 1 ;
                            free((yyvsp[(1) - (2)]));
                            free((yyvsp[(2) - (2)]));
			  } else if ( strncmp((yyvsp[(1) - (2)]),"PERMISSIONS",11) == 0 ) {
                            char* s1 = strdup("\"permissions\"");
			    __C1((yyval),s1)
                            _ASP->hasPERM = 1 ;
                            free((yyvsp[(1) - (2)]));
                            free((yyvsp[(2) - (2)]));
			  } else if ( strncmp((yyvsp[(1) - (2)]),"OWNER",5) == 0 ) {
                            char* s1 = strdup("\"owner\"");
			    __C1((yyval),s1)
                            _ASP->hasOWNER = 1 ;
                            free((yyvsp[(1) - (2)]));
                            free((yyvsp[(2) - (2)]));
			  } else if ( strncmp((yyvsp[(1) - (2)]),"GROUP_RIGHTS",12) == 0 ) {
                            char* s1 = strdup("\"group_rights\"");
			    __C1((yyval),s1)
                            _ASP->hasGROUP = 1 ;
                            free((yyvsp[(1) - (2)]));
                            free((yyvsp[(2) - (2)]));
                          } else { 
			    char* s1 = strdup("\"user:");
			    char* s2 = strdup("\"");
                            char* s3;
			    __B3(s3,s1,(yyvsp[(1) - (2)]),s2) 
			    __B2((yyval),s3,(yyvsp[(2) - (2)])) 
			  }
			;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 866 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 867 "amga_sql_yacc.y++"
    { __C3((yyval),(yyvsp[(1) - (3)]),(yyvsp[(2) - (3)]),(yyvsp[(3) - (3)])) ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 872 "amga_sql_yacc.y++"
    {
			__C6((yyval),(yyvsp[(1) - (6)]),(yyvsp[(2) - (6)]),(yyvsp[(3) - (6)]),(yyvsp[(4) - (6)]),(yyvsp[(5) - (6)]),(yyvsp[(6) - (6)]))
		;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 878 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 879 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 883 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 884 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 885 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 889 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 893 "amga_sql_yacc.y++"
    { __C4((yyval),(yyvsp[(1) - (4)]),(yyvsp[(2) - (4)]),(yyvsp[(3) - (4)]),(yyvsp[(4) - (4)])) ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 897 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 898 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])); ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 899 "amga_sql_yacc.y++"
    { __C2((yyval),(yyvsp[(1) - (2)]),(yyvsp[(2) - (2)])) ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 903 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 904 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 905 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 909 "amga_sql_yacc.y++"
    { __C0((yyval)) ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 910 "amga_sql_yacc.y++"
    { __C1((yyval),(yyvsp[(1) - (1)])) ;}
    break;



/* Line 1455 of yacc.c  */
#line 3457 "amga_sql_yacc.cpp"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 916 "amga_sql_yacc.y++"


char* __concat(char*a, char*b){
  int len = strlen(a) + strlen(b) + 2 ;
  char* temp = (char*) malloc(len) ;
  bzero(temp, len);
  sprintf(temp, "%s %s",a,b);
  free(a);
  free(b);
  return temp;
}

char* __concat3(char*a, char*b, char*c){
  int len = strlen(a) + strlen(b) + strlen(c) + 3 ;
  char* temp = (char*) malloc(len);
  bzero(temp, len);
  sprintf(temp, "%s %s %s",a,b,c);
  free(a);
  free(b);
  free(c);
  return temp;
}

char* __Bconcat(char*a, char*b){
  int len = strlen(a) + strlen(b) + 1 ;
  char* temp = (char*) malloc(len) ;
  bzero(temp, len);
  sprintf(temp, "%s%s",a,b);
  free(a);
  free(b);
  return temp;
}

char* __Bconcat3(char*a, char*b, char*c){
  int len = strlen(a) + strlen(b) + strlen(c) + 1 ;
  char* temp = (char*) malloc(len);
  bzero(temp, len);
  sprintf(temp, "%s%s%s",a,b,c);
  free(a);
  free(b);
  free(c);
  return temp;
}


void sqlyyerror (const char *s) {
	DMESG("ERROR : " << s << " \n");
}

int yylex(YYSTYPE *lvalp, void* a)  {
  int ret ;
  AmgaSqlParser* asp = (AmgaSqlParser*) a; 
  ret = asp->yylex();
  *lvalp = asp->getVal();
  return ret;
}


int getColumn( AmgaSqlParser *scanner, std::string& column, 
               std::map <int, dbTable> :: iterator uTi , bool insert){

  MDServer *mds = scanner->mdserver ;
  AttrList keys;

  int res = mds->getAttributes(uTi->second.dbname, keys, scanner->isPlain);
  if(res || ( keys.size() == 0 ) ) {
    if( res ) DMESG("Not Valid Attributes in the table \n");
    if( keys.size() == 0 ) DMESG("Not Valid Attributes 2 \n");
    scanner->parseResult = strdup("No valid Attribute");
    scanner->error = ER_NOT_VALID_TABLE_NAME ;
    return -1 ;
  }

  AttrList::const_iterator I=keys.begin();

  int k = 0;

  /* The following is appended specially for insert */
  if ( scanner->isPlain == 0 ) {
    if ( insert ) { 
      column.append("\"owner\",");
      column.append("\"permissions\",");
      column.append("\"group_rights\",");
      column.append("\"file\",");
    } else {
      column.append(uTi->second.dbname);
      column.append(".\"file\",");
  
      if ( scanner->countingColumn() ) {
        scanner->numColumn += 1 ;
        std::string tmpStr ;
        if ( uTi->second.alias.size() != 0 ) {
          tmpStr = uTi->second.alias + ".FILE" ;
        } else {
          tmpStr = uTi->second.table + ".FILE" ;
        }
        scanner->usedAttr.insert( TAttribute(scanner->numColumn + k, tmpStr));
      }
    }
  }


  do {
    
    if( k != 0 ) column.append(" ,");
    k++;

    if( insert == false ) {
      if ( uTi->second.alias.size() != 0 ) {
        column.append(uTi->second.alias);
      } else {
        column.append(uTi->second.dbname);
      }
      column.append(".");
    }

    column.append(USER_STRING);
    column.append((*I).first);
    column.append("$");

    if ( (insert == false) && scanner->countingColumn() ) {
      std::string tmpStr ;
      if ( uTi->second.alias.size() != 0 ) {
        tmpStr = uTi->second.alias + "." + (*I).first;
      } else {
        tmpStr = uTi->second.table + "." + (*I).first;
      }

      scanner->usedAttr.insert( TAttribute(scanner->numColumn + k, tmpStr));
    }

    I++;  
  } while(I != keys.end()) ;

  if (scanner->countingColumn() ) {
    scanner->numColumn += keys.size() ;
  }

  return 0;
}


/* It retrieve all column names (both user given column name and real db column ) */

int getAllColumn( AmgaSqlParser *scanner, std::string& column, bool insert){

  int ret ;

  std::map <int, dbTable> :: iterator uTi;

  if( insert ) {
    uTi = scanner->usedTable.begin();
    ret = getColumn ( scanner, column, uTi, insert ) ;
    return ret ;
  } else {
    uTi = scanner->fromTable.begin();
    while(uTi!=scanner->fromTable.end()) {
      if ( uTi->first > 1 ) column.append(" ,"); 
      ret = getColumn ( scanner, column, uTi, insert ) ;
      if ( ret != 0 ) return ret;
      uTi++;
    }
  }

  return 0;
}

/************/
/* 1. ProcessTable translate given table name into the real db table name */
/* 2. Translated real db table name is stored at the variable result      */
/* 3. The input variable alias, and checkPerm is not used any more        */
/************/

int processTable(AmgaSqlParser *scanner, 
                 std::string table, 
                 bool alias, 
                 bool checkPerm, 
                 std::string& result) 
{

  MDServer *mds = scanner->mdserver  ;

  /* search table name from the cached table list, usedTable */
  int count = 0;
  std::map <int, dbTable> :: iterator uTi;
  uTi = scanner->usedTable.begin();
  while(uTi!=scanner->usedTable.end()) {
    if (uTi->second.table == table ) 
      break;
    uTi++;
    count++;
  }

  /* if table name is found from the cached table list, usedTable */
  /*   it returns translated db table name                        */
  if( uTi != scanner->usedTable.end() ) {
    scanner->tmpReferTable = table;
    scanner->tmpReferFlags = uTi->second.flags;
    result = uTi->second.dbname;
    return 0;
  } 

  /* If table name is not found in usedTable ,                         */
  /*   then it tries to translate the table name to real db table name */
  std::list<EntryProps> propList;
  int error=mds->getEntryProps(table, propList);
  if(mds->handleEntryPropErrors(error, table))  {
    if(scanner->parseResult == NULL ) {
      if( error == 100 ) {
        scanner->parseResult = 
          strdup(propList.begin()->directoryTable.c_str());
        scanner->error = 100;
      } else {
        scanner->parseResult = strdup("No valid directory");
        scanner->error = ER_NOT_VALID_TABLE_NAME2 ;
      }
    }
    return -1;
  }

  EntryProps p(*propList.begin());
   
  /* It decide the priviledge to check on the given table */
  std::list< std::string > groups;
  char perm ;
  switch ( scanner->sqlType ) {
    case MDInterpreter::cSELECT :
         perm = 'r'; break;
    case MDInterpreter::cDELETE :
         scanner->sticky = p.sticky();
    case MDInterpreter::cINSERT :
    case MDInterpreter::cUPDATE :
         perm = 'w'; break;
    default:
         perm = 'w'; break;
  }

  /* If given table name does not refer real db table,       */
  /*   it return error                                       */
  /* If given table name is alias, then it return alias name */
  if( (p.flags & EP_TYPE) == EPT_NONE) {
    if(alias) {
      result = table ;
      scanner->tmpReferTable = table;
      scanner->tmpReferFlags = p.flags;
      return 0;
    }
    if(scanner->parseResult == NULL )
      scanner->parseResult = strdup("Invalid Table Name");

    scanner->error = ER_NOT_VALID_TABLE_NAME ;
    return -1;
  } 

  /* If no entries are included in the table given,         */
  /*   there is no matching db table, so that it return error */
  if( p.directoryTable.length() == 0 ) {
      if(scanner->parseResult == NULL )
        scanner->parseResult = strdup("No Entry in the Table");
      scanner->error = ER_NO_ENTRY_IN_TABLE ;
      return -1;
  } 

  /* If accessing is not allowed on the decided permission, it return error */
  
  if (!mds->checkPermResult(mds->checkPermissions(p, perm, groups))) {
      if(scanner->parseResult == NULL )
        scanner->parseResult = strdup("Permission Error");
      scanner->error = ER_PERMISSION_NOT_ALLOWED ;
      return -1;
  } 
  

  /* It saves the info of whether the table is plain or not         */
  /* This info is used to translate column name later               */
  /* In a single SQL query, all tables should be plain or non-plain */ 
  if( p.flags & EP_PLAIN) {
    scanner->isPlain = 1;
  } else {
    scanner->isPlain = 0;
  }

  /* The firstReferTable variable is used for replication later    */
  if ( scanner->firstRefered == 1 )  {
    scanner->firstReferTable = p.name ;
    scanner->firstRefered = 0;
  }

  /* The lastReferTable is used for SELECT * FROM .. */
  /* This should be removed                          */
  /* scanner->lastReferTable = p.directoryTable ;    */

  /* The tmpReferTable is used to remember recently visited table name */
  /* This info is used to get user given attribute name                */
  scanner->tmpReferTable = table ;
  scanner->tmpReferFlags = p.flags ;

  /* It stores table name, transalated db table name into usedTable */
  scanner->insertUsedTable(table, p.directoryTable, p.flags);


  /* It returns the translated db table name  */
  result = p.directoryTable;
  return 0;
}

char* fillPermission(AmgaSqlParser *scanner, char permission)
{
  std::string query ;
  MDStandalone *mds = (MDStandalone*) scanner->mdserver ;

  std::map <int, dbTable> :: iterator uTi;
  uTi = scanner->fromTable.begin();
  while(uTi!=scanner->fromTable.end()) {
    std::list< std::string > groups;
    query += " AND "
      + mds->permissionClause(permission, uTi->second.flags, 
                         groups, uTi->second.dbname);
    uTi++;
  }
  return strdup(query.c_str());
}

