
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 30 "parser.y++"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "Constant.h"
#include "Relation.h"
#include "Negation.h"
#include "Function.h"
#include "Elements.h"
#include "TableColumn.h"
#include "Limit.h"
#include "Order.h"
#include "GroupBy.h"
#include "Distinct.h"
#include "Join.h"

#include <iostream>
#include "ScannerContext.h"

using namespace QueryParser;

#define yyscan_t void *
#define YYSTYPE QueryParser::Expression *

extern int yyerror(char *);
extern int yydebug;

extern Expression *rootExpression;

#define YYERROR_VERBOSE
#define YYPARSE_PARAM scanner
#define YYLEX_PARAM  &(((ScannerContext *)scanner)->lexer)
#define YYDEBUG 1

int yylex( YYSTYPE * lvalp, QueryLexer *lexer);



/* Line 189 of yacc.c  */
#line 113 "parser.c++"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     CONSTANT = 258,
     COLUMN = 259,
     TABLE = 260,
     END_OF_FILE = 261,
     ERROR = 262,
     BI_AND = 264,
     BI_OR = 266,
     BI_GE = 268,
     BI_LE = 270,
     BI_NE = 273,
     BI_OVERLAPS = 275,
     NEG = 276,
     BI_NULL = 278,
     BI_LOWER = 279,
     BI_UPPER = 280,
     BI_COUNT = 281,
     BI_ABS = 282,
     BI_SIN = 283,
     BI_COS = 284,
     BI_TAN = 285,
     BI_ATAN = 286,
     BI_SQRT = 287,
     BI_LOG = 288,
     BI_LN = 289,
     BI_RND = 290,
     BI_SUM = 291,
     BI_MAX = 292,
     BI_MIN = 293,
     BI_AVG = 294,
     BI_LENGTH = 295,
     BI_POW = 296,
     BI_MOD = 297,
     BI_CONCAT = 298,
     BI_LIKE = 299,
     BI_SUBSTR = 300,
     BI_GEOMFROMTEXT = 301,
     BI_MPOLYFROMTEXT = 302,
     BI_CONTAINS = 303,
     BI_ASTEXT = 304,
     BI_LIMIT = 305,
     BI_OFFSET = 306,
     BI_DISTINCT = 307,
     BI_ORDER = 308,
     BI_GROUP_BY = 309,
     BI_JOIN_LEFT_USING = 310,
     BI_JOIN_LEFT_ON = 311,
     BI_JOIN_RIGHT_USING = 312,
     BI_JOIN_RIGHT_ON = 313,
     BI_JOIN_INNER_USING = 314,
     BI_JOIN_INNER_ON = 315,
     BI_JOIN_CROSS = 316,
     BI_JOIN_CROSS_ON = 317,
     BI_IF = 318,
     BI_NOTNULL = 319,
     BI_ISNULL = 320
   };
#endif
/* Tokens.  */
#define CONSTANT 258
#define COLUMN 259
#define TABLE 260
#define END_OF_FILE 261
#define ERROR 262
#define BI_AND 264
#define BI_OR 266
#define BI_GE 268
#define BI_LE 270
#define BI_NE 273
#define BI_OVERLAPS 275
#define NEG 276
#define BI_NULL 278
#define BI_LOWER 279
#define BI_UPPER 280
#define BI_COUNT 281
#define BI_ABS 282
#define BI_SIN 283
#define BI_COS 284
#define BI_TAN 285
#define BI_ATAN 286
#define BI_SQRT 287
#define BI_LOG 288
#define BI_LN 289
#define BI_RND 290
#define BI_SUM 291
#define BI_MAX 292
#define BI_MIN 293
#define BI_AVG 294
#define BI_LENGTH 295
#define BI_POW 296
#define BI_MOD 297
#define BI_CONCAT 298
#define BI_LIKE 299
#define BI_SUBSTR 300
#define BI_GEOMFROMTEXT 301
#define BI_MPOLYFROMTEXT 302
#define BI_CONTAINS 303
#define BI_ASTEXT 304
#define BI_LIMIT 305
#define BI_OFFSET 306
#define BI_DISTINCT 307
#define BI_ORDER 308
#define BI_GROUP_BY 309
#define BI_JOIN_LEFT_USING 310
#define BI_JOIN_LEFT_ON 311
#define BI_JOIN_RIGHT_USING 312
#define BI_JOIN_RIGHT_ON 313
#define BI_JOIN_INNER_USING 314
#define BI_JOIN_INNER_ON 315
#define BI_JOIN_CROSS 316
#define BI_JOIN_CROSS_ON 317
#define BI_IF 318
#define BI_NOTNULL 319
#define BI_ISNULL 320




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 269 "parser.c++"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  76
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1187

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  79
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  9
/* YYNRULES -- Number of rules.  */
#define YYNRULES  76
/* YYNRULES -- Number of states.  */
#define YYNSTATES  260

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   320

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      76,    77,    26,    24,    78,    25,     2,    27,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    75,     2,
      20,    21,    19,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    73,     2,    74,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    22,    23,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     6,     9,    12,    15,    17,    19,
      21,    23,    25,    28,    31,    36,    43,    45,    47,    51,
      55,    59,    63,    67,    71,    75,    79,    83,    87,    91,
      95,    99,   103,   106,   110,   115,   120,   125,   130,   135,
     140,   145,   150,   155,   160,   165,   170,   175,   180,   185,
     190,   197,   206,   213,   220,   227,   232,   237,   244,   249,
     258,   263,   268,   271,   276,   279,   282,   284,   286,   288,
     297,   306,   315,   324,   333,   342,   351
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      80,     0,    -1,    -1,    84,    -1,    80,    86,    -1,    80,
       6,    -1,    80,     7,    -1,     4,    -1,     3,    -1,    30,
      -1,    83,    -1,    82,    -1,     5,     4,    -1,     5,    83,
      -1,     4,    73,     3,    74,    -1,     4,    73,     3,    75,
       3,    74,    -1,    81,    -1,    85,    -1,    76,    84,    77,
      -1,    84,    21,    84,    -1,    84,    20,    84,    -1,    84,
      19,    84,    -1,    84,    15,    84,    -1,    84,    13,    84,
      -1,    84,    18,    84,    -1,    84,    23,    84,    -1,    84,
      24,    84,    -1,    84,    25,    84,    -1,    84,    26,    84,
      -1,    84,    27,    84,    -1,    84,     9,    84,    -1,    84,
      11,    84,    -1,    25,    84,    -1,    42,    76,    77,    -1,
      31,    76,    84,    77,    -1,    32,    76,    84,    77,    -1,
      33,    76,    84,    77,    -1,    34,    76,    84,    77,    -1,
      35,    76,    84,    77,    -1,    36,    76,    84,    77,    -1,
      37,    76,    84,    77,    -1,    38,    76,    84,    77,    -1,
      39,    76,    84,    77,    -1,    40,    76,    84,    77,    -1,
      41,    76,    84,    77,    -1,    43,    76,    84,    77,    -1,
      44,    76,    84,    77,    -1,    45,    76,    84,    77,    -1,
      46,    76,    84,    77,    -1,    47,    76,    84,    77,    -1,
      51,    76,    84,    78,    84,    77,    -1,    52,    76,    84,
      78,    84,    78,    84,    77,    -1,    50,    76,    84,    78,
      84,    77,    -1,    48,    76,    84,    78,    84,    77,    -1,
      49,    76,    84,    78,    84,    77,    -1,    53,    76,    84,
      77,    -1,    54,    76,    84,    77,    -1,    55,    76,    84,
      78,    84,    77,    -1,    56,    76,    84,    77,    -1,    70,
      76,    84,    78,    84,    78,    84,    77,    -1,    72,    76,
      84,    77,    -1,    71,    76,    84,    77,    -1,    57,     3,
      -1,    57,     3,    58,     3,    -1,    60,    84,    -1,    61,
      84,    -1,    59,    -1,    87,    -1,     5,    -1,    63,    76,
      87,    78,    87,    78,    84,    77,    -1,    62,    76,    87,
      78,    87,    78,    84,    77,    -1,    65,    76,    87,    78,
      87,    78,    84,    77,    -1,    64,    76,    87,    78,    87,
      78,    84,    77,    -1,    67,    76,    87,    78,    87,    78,
      84,    77,    -1,    66,    76,    87,    78,    87,    78,    84,
      77,    -1,    69,    76,    87,    78,    87,    78,    84,    77,
      -1,    68,    76,    87,    78,    87,    77,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   153,   153,   154,   160,   166,   169,   175,   176,   177,
     178,   179,   183,   188,   196,   204,   217,   218,   219,   220,
     225,   230,   235,   240,   245,   250,   255,   260,   265,   270,
     275,   280,   285,   293,   295,   297,   299,   301,   303,   305,
     307,   309,   311,   313,   315,   317,   319,   321,   323,   325,
     327,   330,   334,   337,   340,   343,   345,   347,   349,   351,
     355,   357,   362,   367,   372,   376,   380,   384,   388,   390,
     394,   398,   402,   406,   410,   414,   418
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "CONSTANT", "COLUMN", "TABLE",
  "END_OF_FILE", "ERROR", "\"and\"", "BI_AND", "\"or\"", "BI_OR", "\">=\"",
  "BI_GE", "\"<=\"", "BI_LE", "\"!=\"", "\"<>\"", "BI_NE", "'>'", "'<'",
  "'='", "\"&&\"", "BI_OVERLAPS", "'+'", "'-'", "'*'", "'/'", "NEG",
  "\"NULL\"", "BI_NULL", "\"lower\"", "\"upper\"", "\"count\"", "\"abs\"",
  "\"sin\"", "\"cos\"", "\"tan\"", "\"atan\"", "\"sqrt\"", "\"log\"",
  "\"ln\"", "\"rnd\"", "\"sum\"", "\"max\"", "\"min\"", "\"avg\"",
  "\"length\"", "\"pow\"", "\"mod\"", "\"concat\"", "\"like\"",
  "\"substr\"", "\"GeomFromText\"", "\"MPolyFromText\"", "\"Contains\"",
  "\"AsText\"", "\"limit\"", "\"offset\"", "\"distinct\"", "\"order\"",
  "\"group_by\"", "\"join_left_using\"", "\"join_left_on\"",
  "\"join_right_using\"", "\"join_right_on\"", "\"join_inner_using\"",
  "\"join_inner_on\"", "\"join_cross\"", "\"join_cross_on\"", "\"if\"",
  "\"notnull\"", "\"isnull\"", "'['", "']'", "':'", "'('", "')'", "','",
  "$accept", "query", "token", "tableCol", "elements", "exp", "function",
  "constraint", "joinCondition", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,    62,
      60,    61,   274,   275,    43,    45,    42,    47,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    91,    93,    58,    40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    79,    80,    80,    80,    80,    80,    81,    81,    81,
      81,    81,    82,    82,    83,    83,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    86,    86,    86,    86,    86,    86,    87,    87,
      87,    87,    87,    87,    87,    87,    87
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     2,     2,     4,     6,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       6,     8,     6,     6,     6,     4,     4,     6,     4,     8,
       4,     4,     2,     4,     2,     2,     1,     1,     1,     8,
       8,     8,     8,     8,     8,     8,     6
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     8,     7,     0,     0,     9,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    11,    10,
       3,    17,     0,    12,    13,    32,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,    68,     5,     6,
       0,    66,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     4,    67,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,    62,    64,
      65,     0,     0,     0,     0,     0,     0,     0,     0,    30,
      31,    23,    22,    24,    21,    20,    19,    25,    26,    27,
      28,    29,    14,     0,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
       0,     0,     0,     0,     0,    55,    56,     0,    58,     0,
      61,    60,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    63,
       0,     0,     0,     0,     0,     0,     0,     0,    15,    53,
      54,    52,    50,     0,    57,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    76,     0,    51,    59,     0,     0,     0,     0,
       0,     0,     0,    70,    69,    72,    71,    74,    73,    75
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    36,    37,    38,    39,    40,    41,    92,    93
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -131
static const yytype_int16 yypact[] =
{
     116,  -131,   -68,    20,   116,  -131,   -50,   -48,   -46,   -40,
      42,    47,    49,    55,    63,    64,    69,    97,    98,    99,
     105,   106,   108,   113,   114,   115,   117,   119,   134,   140,
     141,   142,   144,   148,   154,   116,   137,  -131,  -131,  -131,
      14,  -131,   123,   -68,  -131,  -131,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,    61,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   412,  -131,  -131,  -131,  -131,
     228,  -131,   116,   116,   165,   167,   169,   170,   175,   182,
     184,   186,  -131,  -131,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,    34,   431,   450,
     472,   491,   510,   532,   551,   570,   592,   611,   630,  -131,
     652,   671,   690,   712,   731,   229,   248,   267,   290,   309,
     750,   772,   328,   791,   351,   810,   832,  -131,   206,    14,
      14,    48,    48,    48,    48,    48,    48,    48,    48,  1127,
     109,  1140,   -17,   188,   202,    50,    80,    -5,    62,    62,
    -131,  -131,  -131,   262,  -131,  -131,  -131,  -131,  -131,  -131,
    -131,  -131,  -131,  -131,  -131,  -131,  -131,  -131,  -131,  -131,
     116,   116,   116,   116,   116,  -131,  -131,   116,  -131,   116,
    -131,  -131,   274,    -6,   192,   201,   203,   205,   211,   217,
     218,   210,   851,   870,   892,   911,   370,   930,   389,  -131,
      48,    48,    48,    48,    48,    48,    48,    48,  -131,  -131,
    -131,  -131,  -131,   116,  -131,   116,   219,   220,   222,   224,
     226,   234,   242,   243,   952,   971,   116,   116,   116,   116,
     116,   116,  -131,   116,  -131,  -131,   990,  1012,  1031,  1050,
    1072,  1091,  1110,  -131,  -131,  -131,  -131,  -131,  -131,  -131
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -131,  -131,  -131,  -131,   303,    -4,  -131,  -131,  -130
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      45,    98,    99,   100,   101,    42,   102,   103,   104,   105,
     106,   193,   194,   195,   196,   197,   198,   199,   200,   103,
     104,   105,   106,    94,    43,    95,    46,    96,    47,    97,
      48,    75,    98,    99,   100,   101,    49,   102,   103,   104,
     105,   106,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    77,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   101,   210,   102,   103,   104,   105,   106,   139,   140,
     226,   227,   228,   229,   230,   231,   232,   233,   105,   106,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   102,   103,   104,   105,   106,   162,   163,
      84,    85,    86,    87,    88,    89,    90,    91,    50,     1,
       2,     3,    96,    51,    97,    52,   107,    98,    99,   100,
     101,    53,   102,   103,   104,   105,   106,    76,   119,    54,
      55,     4,    77,    78,    79,    56,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    57,    58,    59,   202,   203,   204,   205,
     206,    60,    61,   207,    62,   208,    32,    33,    34,    63,
      64,    65,    35,    66,    80,    67,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    99,   100,   101,
      68,   102,   103,   104,   105,   106,    69,    70,    71,   234,
      72,   235,   100,   101,    73,   102,   103,   104,   105,   106,
      74,   138,   246,   247,   248,   249,   250,   251,    94,   252,
      95,   141,    96,   142,    97,   143,   144,    98,    99,   100,
     101,   145,   102,   103,   104,   105,   106,    94,   146,    95,
     147,    96,   148,    97,   192,   201,    98,    99,   100,   101,
     211,   102,   103,   104,   105,   106,    94,   209,    95,   212,
      96,   213,    97,   214,   218,    98,    99,   100,   101,   215,
     102,   103,   104,   105,   106,   216,   217,   236,   237,    94,
     238,    95,   239,    96,   240,    97,    44,   180,    98,    99,
     100,   101,   241,   102,   103,   104,   105,   106,    94,   242,
      95,   243,    96,     0,    97,     0,   181,    98,    99,   100,
     101,     0,   102,   103,   104,   105,   106,    94,     0,    95,
       0,    96,     0,    97,     0,   182,    98,    99,   100,   101,
       0,   102,   103,   104,   105,   106,     0,     0,     0,     0,
      94,     0,    95,     0,    96,     0,    97,     0,   183,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   184,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,    94,     0,
      95,     0,    96,     0,    97,     0,   187,    98,    99,   100,
     101,     0,   102,   103,   104,   105,   106,     0,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   189,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   223,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   225,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   137,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   164,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   165,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   166,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   167,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   168,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   169,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   170,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   171,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   172,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   173,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   174,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   175,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   176,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   177,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   178,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   179,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   185,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   186,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   188,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   190,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   191,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   219,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   220,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   221,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   222,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   224,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   244,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   245,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   253,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,     0,     0,
       0,    94,     0,    95,     0,    96,     0,    97,     0,   254,
      98,    99,   100,   101,     0,   102,   103,   104,   105,   106,
      94,     0,    95,     0,    96,     0,    97,     0,   255,    98,
      99,   100,   101,     0,   102,   103,   104,   105,   106,    94,
       0,    95,     0,    96,     0,    97,     0,   256,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,    95,     0,
      96,     0,    97,     0,     0,    98,    99,   100,   101,   257,
     102,   103,   104,   105,   106,    97,     0,     0,    98,    99,
     100,   101,     0,   102,   103,   104,   105,   106,   258,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   259
};

static const yytype_int16 yycheck[] =
{
       4,    18,    19,    20,    21,    73,    23,    24,    25,    26,
      27,   141,   142,   143,   144,   145,   146,   147,   148,    24,
      25,    26,    27,     9,     4,    11,    76,    13,    76,    15,
      76,    35,    18,    19,    20,    21,    76,    23,    24,    25,
      26,    27,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,     5,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    21,    78,    23,    24,    25,    26,    27,    82,    83,
     210,   211,   212,   213,   214,   215,   216,   217,    26,    27,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,    23,    24,    25,    26,    27,    74,    75,
      62,    63,    64,    65,    66,    67,    68,    69,    76,     3,
       4,     5,    13,    76,    15,    76,     3,    18,    19,    20,
      21,    76,    23,    24,    25,    26,    27,     0,    77,    76,
      76,    25,     5,     6,     7,    76,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    76,    76,    76,   180,   181,   182,   183,
     184,    76,    76,   187,    76,   189,    70,    71,    72,    76,
      76,    76,    76,    76,    57,    76,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    19,    20,    21,
      76,    23,    24,    25,    26,    27,    76,    76,    76,   223,
      76,   225,    20,    21,    76,    23,    24,    25,    26,    27,
      76,     3,   236,   237,   238,   239,   240,   241,     9,   243,
      11,    76,    13,    76,    15,    76,    76,    18,    19,    20,
      21,    76,    23,    24,    25,    26,    27,     9,    76,    11,
      76,    13,    76,    15,    58,     3,    18,    19,    20,    21,
      78,    23,    24,    25,    26,    27,     9,     3,    11,    78,
      13,    78,    15,    78,    74,    18,    19,    20,    21,    78,
      23,    24,    25,    26,    27,    78,    78,    78,    78,     9,
      78,    11,    78,    13,    78,    15,     3,    78,    18,    19,
      20,    21,    78,    23,    24,    25,    26,    27,     9,    77,
      11,    78,    13,    -1,    15,    -1,    78,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,     9,    -1,    11,
      -1,    13,    -1,    15,    -1,    78,    18,    19,    20,    21,
      -1,    23,    24,    25,    26,    27,    -1,    -1,    -1,    -1,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    78,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    78,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,     9,    -1,
      11,    -1,    13,    -1,    15,    -1,    78,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,    -1,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    78,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    78,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    78,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,     9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
       9,    -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    27,     9,
      -1,    11,    -1,    13,    -1,    15,    -1,    77,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    11,    -1,
      13,    -1,    15,    -1,    -1,    18,    19,    20,    21,    77,
      23,    24,    25,    26,    27,    15,    -1,    -1,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,    25,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    70,    71,    72,    76,    80,    81,    82,    83,
      84,    85,    73,     4,    83,    84,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    84,     0,     5,     6,     7,
      57,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    86,    87,     9,    11,    13,    15,    18,    19,
      20,    21,    23,    24,    25,    26,    27,     3,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    77,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    77,     3,    84,
      84,    76,    76,    76,    76,    76,    76,    76,    76,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    74,    75,    77,    77,    77,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      78,    78,    78,    78,    78,    77,    77,    78,    77,    78,
      77,    77,    58,    87,    87,    87,    87,    87,    87,    87,
      87,     3,    84,    84,    84,    84,    84,    84,    84,     3,
      78,    78,    78,    78,    78,    78,    78,    78,    74,    77,
      77,    77,    77,    78,    77,    78,    87,    87,    87,    87,
      87,    87,    87,    87,    84,    84,    78,    78,    78,    78,
      78,    78,    77,    78,    77,    77,    84,    84,    84,    84,
      84,    84,    84,    77,    77,    77,    77,    77,    77,    77
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1455 of yacc.c  */
#line 154 "parser.y++"
    {
	  if((yyvsp[(1) - (1)])) 
	    ((ScannerContext *)YYPARSE_PARAM)->rootExpression
	      = (yyvsp[(1) - (1)]);
	  (yyval) = (yyvsp[(1) - (1)]); 
      }
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 160 "parser.y++"
    { if((yyvsp[(2) - (2)])) {
	    Constraint *c = (Constraint *) (yyvsp[(2) - (2)]);
	    ((ScannerContext *)YYPARSE_PARAM)->constraints.push_back(c);
	    (yyval) = (yyvsp[(2) - (2)]);
	  } 
      }
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 166 "parser.y++"
    {
	return yynerrs; 
      }
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 169 "parser.y++"
    {
	yynerrs++; 
      }
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 175 "parser.y++"
    { (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 176 "parser.y++"
    { (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 177 "parser.y++"
    { (yyval) = new Constant("NULL"); }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 178 "parser.y++"
    { (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 179 "parser.y++"
    { (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 184 "parser.y++"
    { TableColumn *tc =new TableColumn((Identifier *) (yyvsp[(2) - (2)]));
			   (yyval) = tc;
			   tc->setTable((Table *) (yyvsp[(1) - (2)]));
			 }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 189 "parser.y++"
    { TableColumn *tc =new TableColumn((Identifier *) (yyvsp[(2) - (2)]));
			   (yyval) = tc;
			   tc->setTable((Table *) (yyvsp[(1) - (2)]));
			 }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 197 "parser.y++"
    { Elements *e=new Elements(*(Identifier *)(yyvsp[(1) - (4)]));
		           delete (yyvsp[(1) - (4)]);
		           (yyval)=e;
		           int i=atoi(((Constant *)(yyvsp[(3) - (4)]))->get().c_str());
		           e->setRange(i, i);
		           delete (yyvsp[(3) - (4)]);
		         }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 205 "parser.y++"
    { Elements *e=new Elements(*(Identifier *)(yyvsp[(1) - (6)]));
			   delete (yyvsp[(1) - (6)]);
		           (yyval)=e;
		           int i=atoi(((Constant *)(yyvsp[(3) - (6)]))->get().c_str());
		           int j=atoi(((Constant *)(yyvsp[(5) - (6)]))->get().c_str());
		           e->setRange(i, j);
		           delete (yyvsp[(3) - (6)]);
		           delete (yyvsp[(5) - (6)]);
		         }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 217 "parser.y++"
    { (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 218 "parser.y++"
    { (yyval)=(yyvsp[(1) - (1)]); }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 219 "parser.y++"
    { (yyval)=(yyvsp[(2) - (3)]); }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 220 "parser.y++"
    { Relation *r = new Relation("=");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 225 "parser.y++"
    { Relation *r = new Relation("<");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 230 "parser.y++"
    { Relation *r = new Relation(">");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 235 "parser.y++"
    { Relation *r = new Relation("<=");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 240 "parser.y++"
    { Relation *r = new Relation(">=");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 245 "parser.y++"
    { Relation *r = new Relation("!=");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 250 "parser.y++"
    { Relation *r = new Relation("&&");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 255 "parser.y++"
    { Relation *r = new Relation("+");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 260 "parser.y++"
    { Relation *r = new Relation("-");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 265 "parser.y++"
    { Relation *r = new Relation("*");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 270 "parser.y++"
    { Relation *r = new Relation("/");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 275 "parser.y++"
    { Relation *r = new Relation("and");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 280 "parser.y++"
    { Relation *r = new Relation("or");
                            r->setLeft((yyvsp[(1) - (3)]));
                            r->setRight((yyvsp[(3) - (3)]));
                           (yyval) = r;
                         }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 285 "parser.y++"
    { Negation *n = new Negation();
                             n->setExpression((yyvsp[(2) - (2)]));
                             (yyval) = n;
                         }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 293 "parser.y++"
    { Function *f= new Function(0, "rnd");
	                 (yyval) = f; }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 295 "parser.y++"
    { Function *f= new Function(1, "lower");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 297 "parser.y++"
    { Function *f= new Function(1, "upper");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 299 "parser.y++"
    { Function *f= new Function(1, "count");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 301 "parser.y++"
    { Function *f= new Function(1, "abs");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 303 "parser.y++"
    { Function *f= new Function(1, "sin");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 305 "parser.y++"
    { Function *f= new Function(1, "cos");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 307 "parser.y++"
    { Function *f= new Function(1, "tan");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 309 "parser.y++"
    { Function *f= new Function(1, "atan");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 311 "parser.y++"
    { Function *f= new Function(1, "sqrt");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 313 "parser.y++"
    { Function *f= new Function(1, "log");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 315 "parser.y++"
    { Function *f= new Function(1, "ln");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 317 "parser.y++"
    { Function *f= new Function(1, "sum");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 319 "parser.y++"
    { Function *f= new Function(1, "max");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 321 "parser.y++"
    { Function *f= new Function(1, "min");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 323 "parser.y++"
    { Function *f= new Function(1, "avg");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 325 "parser.y++"
    { Function *f= new Function(1, "length");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 327 "parser.y++"
    {  Function *f= new Function(2, "like");
	                         f->setArg((yyvsp[(3) - (6)]), 0);
                                 f->setArg((yyvsp[(5) - (6)]), 1); (yyval) = f; }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 330 "parser.y++"
    {
                                 Function *f= new Function(3, "substr");
	                         f->setArg((yyvsp[(3) - (8)]), 0);
                                 f->setArg((yyvsp[(5) - (8)]), 1); f->setArg((yyvsp[(7) - (8)]), 2); (yyval) = f; }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 334 "parser.y++"
    {  Function *f= new Function(2, "concat");
	                         f->setArg((yyvsp[(3) - (6)]), 0);
                                 f->setArg((yyvsp[(5) - (6)]), 1); (yyval) = f; }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 337 "parser.y++"
    {  Function *f= new Function(2, "pow");
	                         f->setArg((yyvsp[(3) - (6)]), 0);
                                 f->setArg((yyvsp[(5) - (6)]), 1); (yyval) = f; }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 340 "parser.y++"
    {  Function *f= new Function(2, "mod");
	                         f->setArg((yyvsp[(3) - (6)]), 0);
                                 f->setArg((yyvsp[(5) - (6)]), 1); (yyval) = f; }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 343 "parser.y++"
    { Function *f= new Function(1, "GeomFromText");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 345 "parser.y++"
    { Function *f= new Function(1, "MPolyFromText");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 347 "parser.y++"
    { Function *f= new Function(2, "Contains");
 	                         f->setArg((yyvsp[(3) - (6)]), 0); f->setArg((yyvsp[(5) - (6)]), 1); (yyval) = f; }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 349 "parser.y++"
    { Function *f= new Function(1, "AsText");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 351 "parser.y++"
    { 
	                        Function *f= new Function(3, "if");
 	                        f->setArg((yyvsp[(3) - (8)]), 0); f->setArg((yyvsp[(5) - (8)]), 1);
 	                        f->setArg((yyvsp[(7) - (8)]), 2); (yyval) = f; }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 355 "parser.y++"
    { Function *f= new Function(1, "isnull");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 357 "parser.y++"
    { Function *f= new Function(1, "notnull");
 	                         f->setArg((yyvsp[(3) - (4)]), 0); (yyval) = f; }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 362 "parser.y++"
    { 
                           Limit *l = new Limit(((Constant *)(yyvsp[(2) - (2)]))->toInt());
                           delete (yyvsp[(2) - (2)]);
                           (yyval) = l;
                         }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 367 "parser.y++"
    {
	                   Limit *l = new Limit(((Constant *)(yyvsp[(2) - (4)]))->toInt(),
			                        ((Constant *)(yyvsp[(4) - (4)]))->toInt());
                           delete (yyvsp[(2) - (4)]); delete (yyvsp[(4) - (4)]);
                           (yyval) = l; }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 372 "parser.y++"
    {
	                   Order *o = new Order( (yyvsp[(2) - (2)]) );
	                   (yyval) = o;
                     }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 376 "parser.y++"
    {
	                   GroupBy *o = new GroupBy( (yyvsp[(2) - (2)]) );
	                   (yyval) = o;
                     }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 380 "parser.y++"
    {
	                   Distinct *d = new Distinct( );
	                   (yyval) = d;
                    }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 384 "parser.y++"
    {    (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 388 "parser.y++"
    {     (yyval) = (yyvsp[(1) - (1)]); }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 390 "parser.y++"
    {
                           Join * j = new Join(JOIN_LEFT_ON, (yyvsp[(3) - (8)]), (yyvsp[(5) - (8)]), (yyvsp[(7) - (8)]));
 	                   (yyval) = j;
                     }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 394 "parser.y++"
    {
                           Join * j = new Join(JOIN_LEFT_USING, (yyvsp[(3) - (8)]), (yyvsp[(5) - (8)]), (yyvsp[(7) - (8)]));
 	                   (yyval) = j;
                     }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 398 "parser.y++"
    {
                           Join * j = new Join(JOIN_RIGHT_ON, (yyvsp[(3) - (8)]), (yyvsp[(5) - (8)]), (yyvsp[(7) - (8)]));
 	                   (yyval) = j;
                     }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 402 "parser.y++"
    {
                           Join * j = new Join(JOIN_RIGHT_USING, (yyvsp[(3) - (8)]), (yyvsp[(5) - (8)]), (yyvsp[(7) - (8)]));
 	                   (yyval) = j;
                     }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 406 "parser.y++"
    {
                           Join * j = new Join(JOIN_INNER_ON, (yyvsp[(3) - (8)]), (yyvsp[(5) - (8)]), (yyvsp[(7) - (8)]));
 	                   (yyval) = j;
                     }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 410 "parser.y++"
    {
                           Join * j = new Join(JOIN_INNER_USING, (yyvsp[(3) - (8)]), (yyvsp[(5) - (8)]), (yyvsp[(7) - (8)]));
 	                   (yyval) = j;
                     }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 414 "parser.y++"
    {
                           Join * j = new Join(JOIN_CROSS_ON, (yyvsp[(3) - (8)]), (yyvsp[(5) - (8)]), (yyvsp[(7) - (8)]));
 	                   (yyval) = j;
                     }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 418 "parser.y++"
    {
                           Join * j = new Join(JOIN_CROSS, (yyvsp[(3) - (6)]), (yyvsp[(5) - (6)]));
 	                   (yyval) = j;
                     }
    break;



/* Line 1455 of yacc.c  */
#line 2532 "parser.c++"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 424 "parser.y++"


int yylex( YYSTYPE *lvalp, QueryLexer *lexer)
{
  int result = lexer->yylex();
  *lvalp = lexer->getVal();
  return result;
}

int yyerror(char *m)
{
//  std::cout << "Error parsing input: "<< m << std::endl;
  return (0);
}



/* void yyprint(FILE *file, int type, YYSTYPE value){ */
/*   cout << type << endl; */
/* } */

